/*
 * @(#)i386_float_md.c	1.5 00/11/09
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#include "javavm/include/porting/float.h"

#if (!defined(JAVA_COMPLIANT_f2i) && !defined(NAN_CHECK_f2i))

#undef _isnan
#define _isnan(d)	CVMfloatCompare(d, d, 1)

CVMJavaInt
float2Int(CVMJavaFloat f)
{
    CVMJavaLong ltmp = (CVMJavaLong)f;
    CVMJavaInt itmp = (CVMJavaInt)ltmp;

    if (itmp == ltmp) {
	return itmp;
    } else {
	if (_isnan((double)f)) {
	    return 0;
	}
	if (f < 0.0) {
	    return 0x80000000;
	} else {
	    return 0x7fffffff;
	}
    }
}

#endif  /* (!defined(JAVA_COMPLIANT_f2i) && !defined(NAN_CHECK_f2i)) */


#if (!defined(JAVA_COMPLIANT_f2l) && !defined(NAN_CHECK_f2l))

CVMJavaLong
float2Long(CVMJavaFloat f)
{
    CVMJavaLong ltmp = (CVMJavaLong)f;
    if (ltmp != 0x8000000000000000LL) {
        return ltmp;
    } else {
        if (_isnan((double)f)) {
	    return 0;
	}
        if (f < 0.0) {
            return 0x8000000000000000LL;
        } else {
            return 0x7fffffffffffffffLL;
        }
    }
}

#endif /* (!defined(JAVA_COMPLIANT_f2l) && !defined(NAN_CHECK_f2l)) */

#if (!defined(JAVA_COMPLIANT_d2i) && !defined(NAN_CHECK_d2i))

CVMJavaInt
double2Int(CVMJavaDouble d)
{
    CVMJavaLong ltmp = (CVMJavaLong)d;
    CVMJavaInt itmp = (CVMJavaInt)ltmp;

    if (itmp == ltmp) {
	return itmp;
    } else {
	if (_isnan(d)) {
	    return 0;
	}
	if (d < 0.0) {
	    return 0x80000000;
	} else {
	    return 0x7fffffff;
	}
    }
}

#endif /* (!defined(JAVA_COMPLIANT_d2i) && !defined(NAN_CHECK_d2i)) */

#if (!defined(JAVA_COMPLIANT_d2l) && !defined(NAN_CHECK_d2l))

CVMJavaLong
double2Long(CVMJavaDouble d)
{
    CVMJavaLong ltmp = (CVMJavaLong)d;
    if (ltmp != 0x8000000000000000LL) {
        return ltmp;
    } else {
        if (_isnan(d)) {
	    return 0;
	}
        if (d < 0.0) {
            return 0x8000000000000000LL;
        } else {
            return 0x7fffffffffffffffLL;
        }
    }
}

#endif /* (!defined(JAVA_COMPLIANT_d2l) && !defined(NAN_CHECK_d2l)) */
