/*
 * @(#)sync.h	1.5 00/09/13
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _POSIX_SYNC_H
#define _POSIX_SYNC_H

#include <pthread.h>

typedef struct {
    pthread_mutex_t m;
} POSIXMutex;

typedef struct {
    pthread_cond_t c;
} POSIXCondVar;


extern CVMBool POSIXmutexInit(POSIXMutex * m);
extern void POSIXmutexDestroy(POSIXMutex * m);
extern CVMBool POSIXmutexTryLock(POSIXMutex * m);
extern void POSIXmutexLock(POSIXMutex * m);
extern void POSIXmutexUnlock(POSIXMutex * m);

extern CVMBool POSIXcondvarInit(POSIXCondVar * c, POSIXMutex * m);
extern void POSIXcondvarDestroy(POSIXCondVar * c);
extern int POSIXcondvarWait(POSIXCondVar * c, POSIXMutex * m,
	CVMJavaLong millis);
extern void POSIXcondvarNotify(POSIXCondVar * c);
extern void POSIXcondvarNotifyAll(POSIXCondVar * c);

#endif /* _POSIX_SYNC_H */
