/*
 * -----------------------------------------------------------------
 *  threads.h :
 *
 * Copyright (C) 2001 TimeSys Corporation, All Rights Reserved.
 *
 * This software is subject to the terms and conditions of the
 * accompanying TimeSys Community Source License Agreement from TimeSys
 * in file TCSL.
 *
 * This file is derived from software distributed under the following terms:
 *
 * Sun Community Source License
 * Sun Microsystems
 * For details, see http://www.sun.com/981208/scsl/principles.html
 *
 * Your use of this software indicates your acceptance of these terms.
 * -----------------------------------------------------------------
 */


/*
 * @(#)threads.h	1.6 00/07/17
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _POSIX_THREADS_H
#define _POSIX_THREADS_H

extern void POSIXthreadInitStaticState();
extern void POSIXthreadDestroyStaticState();

extern CVMInt32 POSIXthreadCreate(CVMSize stackSize, CVMInt16 priority,
    void (*func)(void *), void *arg);

extern CVMInt32 POSIXthreadCreateEx(CVMSize stackSize, CVMInt16 priority, CVMInt16 policy,
    void (*func)(void *), void *arg);

extern CVMThreadID * POSIXthreadGetSelf();

extern void POSIXthreadAttach(CVMThreadID *self);
extern void POSIXthreadDetach(CVMThreadID *self);

extern void POSIXthreadSetPriority(CVMThreadID *t, CVMInt32 priority);
extern void POSIXthreadGetPriority(CVMThreadID *t, CVMInt32 *priority);

/*Added by Kalpesh*/
extern void POSIXthreadSendSig(CVMThreadID* t);

#endif /* _POSIX_THREADS_H */
