#
#  Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
#
#
#  @(#)defs_vxworks.mk	1.41 00/07/20
#
# defs for VxWorks target
#
CVM_TARGET      = vxworks

HOST_TYPE	= $(shell uname)

#
# Location of JDK tools and JDK sources we use.
#
ifeq ($(HOST_TYPE), SunOS)
CVM_BOOTDIR	   = $(JDK_HOME)/solaris
CVM_JAVABIN	   = $(CVM_BOOTDIR)/bin
endif

FILESEP=/

#
# Tools
#
LIB_FLAGS       = -nostdlib -Wl,-r
AR_CREATE_FLAGS = rc
AR_UPDATE_FLAGS = ts
ifeq ($(CPU), SIMSPARCSOLARIS)
INVOKENATIVE	= invokeNative_sparc
CVM		= cvm.o
#LINKFLAGS	= $(LDFLAGS) $(LD_PARTIAL_FLAGS)
LINKFLAGS	= -nostdlib -r
endif
ifeq ($(CPU), I80486)
INVOKENATIVE	= invokeNative_x86
CVM		= cvm.o
LINKFLAGS	= -nostdlib -r
endif
ifeq ($(CPU), PENTIUM)
INVOKENATIVE	= invokeNative_x86
CVM		= cvm.o
LINKFLAGS	= -nostdlib -r
endif
ifeq ($(CPU), SIMNT)
INVOKENATIVE	= invokeNative_x86
CVM		= cvm.obj
endif
AS		= $(CC)
ZIP	        = ZIP
LIB             = $(CC)
CVMLIB         = cvm.lib

#
# Platform specific source directories
#
CVM_SRCDIRS   += $(CVM_TOP)/src/porting/ansi_c
CVM_SRCDIRS   += $(CVM_TOP)/src/porting/posix
CVM_SRCDIRS   += $(CVM_TOP)/src/porting/i386
CVM_INCLUDES  += -I$(CVM_TOP)/src

#
# rules for running tools
#
ASM_RULE  = $(AT)$(AS) -traditional -c -D_ASM $(CPPFLAGS) -o $@ $<
CC_RULE   = $(AT)$(CC) $(CFLAGS) -o $@ $<
LINK_RULE = $(AT)$(LD) $(LINKFLAGS) -o $@ $^ $(LINKLIBS)
LIB_RULE  = $(AT)$(LIB) $(LIB_FLAGS) -g -o $@ $^ 

#
#  Compiler flags
#

ifeq ($(CVM_OPTIMIZED), true)
# gcc optmized
CCFLAGS     = -O4 -Wall
else
# gcc debug
CCFLAGS     = -Wall
endif

ifeq ($(CVM_SYMBOLS), true)
CCFLAGS += -g
endif

CCDEPEND    = -M

CPPFLAGS = $(CVM_DEFINES) $(CVM_INCLUDES) $(CC_DEFINES) $(CC_INCLUDE)
#EXTRA_DEFINES = $(CVM_DEFINES)
#PRE_INCLUDE = $(CVM_INCLUDES)
#EXTRA_INCLUDE = $(CVM_INCLUDES)
CFLAGS   += -c $(CCFLAGS) $(CVM_DEFINES) $(CVM_INCLUDES)

LINKLIBS =

ifeq ($(CPU), I80486)
	CVM_TARGETOBJS += i386_float_md.o
endif

ifeq ($(CPU), PENTIUM)
	CVM_TARGETOBJS += i386_float_md.o
endif

ifeq ($(CPU), SIMNT)
	CVM_TARGETOBJS += i386_float_md.o
endif

ifeq ($(CVM_DYNAMIC_LINKING), true)
	CVM_TARGETOBJS += linker_md.o
endif

#
# All the platform specific build flags we need to keep track of in
# case they are toggled. OK to leave the CVM_ prefix off.
#
CVM_FLAGS += CPU

CPU_CLEANUP_ACTION = $(CVM_DEFAULT_CLEANUP_ACTION)

#
# Include the right configuration and profile specific makefiles
#
include ../vxworks/defs_cdc_vxworks.mk
ifneq ($(CLASSLIB), cdc)
include ../vxworks/defs_$(CLASSLIB)_vxworks.mk
endif
