#
#  Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
#
#
#  @(#)rules_vxworks.mk	1.6 00/05/25
#
# rules for VxWorks target
#

#
# Rules for building bsp, boot disk image and downloadable image.
#

download_image: $(TORNADO2DIR)/default/vxWorks

download_image_clean:
	@echo ">>>Making "$@" ..." ;
	(rm -rf $(TORNADO2DIR)/default)
	(rm -f $(TORNADO2DIR)/*.lst)
	@echo "<<<Finished "$@" ..." ;

boot_disk:
	@echo ">>>Making "$@" ..." ;
	-volcheck
	cp $(WIND_BASE)/FLOPPY-BOOT/boot-disk.14 $(DISK_DEVICE)
	eject
	@echo "<<<Finished "$@" ..." ;

boot_rom: bsp_file
	@echo ">>>Making "$@" ..." ;
	(cd $(TORNADO2DIR)-boot; \
	$(MAKE) bootrom; \
	objcopy386 -O binary bootrom bootrom.sys; \
	volcheck; \
	cp bootrom.sys $(MOUNTED_DISK); \
	eject)
	@echo "<<<Finished "$@" ..." ;



bsp_file:: $(TORNADO2DIR)-boot/vxWorks

bsp_clean:: download_image_clean
	@echo ">>>Making "$@" ..." ;
	(cd $(TORNADO2DIR)-boot; $(MAKE) clean)
	@echo "<<<Finished "$@" ..." ;

default_dir:: $(TORNADO2DIR)/default



$(TORNADO2DIR)-boot/vxWorks::
	@echo ">>>Making "$@" ..." ;
	(cd $(TORNADO2DIR)-boot; $(MAKE))
	@echo "<<<Finished "$@" ..." ;

$(TORNADO2DIR)/default::
	mkdir -p $(TORNADO2DIR)/default

$(TORNADO2DIR)/default/vxWorks:: all bsp_file default_dir
	@echo ">>>Making "$@" ..." ;
	(cd $(TORNADO2DIR)/default; \
	$(MAKE) -f ../Makefile BUILD_SPEC=default DEFAULT_RULE=vxWorks vxWorks)
	@echo "<<<Finished "$@" ..." ;
