/*
 * -----------------------------------------------------------------
 * MemoryAccessError.java : The exceptin thrown when an attempt is
 * made to access an inaccessible memory region. 
 *
 * Copyright (C) 2001 TimeSys Corporation, All Rights Reserved.
 *
 * This software is subject to the terms and conditions of the
 * accompanying Common Public License in file CPLicense.  Your use
 * of this software indicates your acceptance of these terms.
 * -----------------------------------------------------------------
 */

package javax.realtime;

/**
 * This error is thrown on an attempt to refer to an object in
 * an inaccessible {@link MemoryArea}. For example this
 * will be thrown if logic in a {@link NoHeapRealtimeThread}
 * attempts to refer to an object in the traditional Java heap.
 *
 * @author Pratik Solanki
 */
public class MemoryAccessError extends java.lang.Error
{
    /**
     * A constructor for <code>MemoryAccessError</code>.
     */
	public MemoryAccessError()
	{
		super();
	}

    /**
     * A descriptive constructor for <code>MemoryAccessError</code>.
     *
     * @param description Description of the error.
     */
	public MemoryAccessError(String description)
	{
		super(description);
	}
}
