/*
 * -----------------------------------------------------------------
 * SizeOutOfBoundsException.java :
 *
 * Copyright (C) 2001 TimeSys Corporation, All Rights Reserved.
 *
 * This software is subject to the terms and conditions of the
 * accompanying Common Public License in file CPLicense.  Your use
 * of this software indicates your acceptance of these terms.
 * -----------------------------------------------------------------
 */

package javax.realtime;

/**
 * Thrown if the constructor of an {@link ImmortalPhysicalMemory},
 * {@link LTPhysicalMemory}, {@link VTPhysicalMemory}, {@link RawMemoryAccess}, or
 * {@link RawMemoryFloatAccess} is given an invalid size or if an 
 * accessor method on one of the above classes would cause access to 
 * an invalid address.
 *
 * @author Pratik Solanki
 */
public class SizeOutOfBoundsException extends Exception
{
    /**
     * A constructor for <code>SizeOutOfBoundsException</code>.
     */
    public SizeOutOfBoundsException()
    {
    }

    /**
     * A descriptive constructor for <code>SizeOutOfBoundsException</code>.
     *
     * @param description The description of the exception.
     */
    public SizeOutOfBoundsException(String description)
    {
        super(description);
    }
}
