/*
 * @(#)io_md.h	1.3 00/11/07
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * Machine-dependent I/O definitions.
 */

#ifndef _LINUX_IO_MD_H
#define _LINUX_IO_MD_H

#include "javavm/include/porting/vm-defs.h"

#include <sys/param.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>

#if defined(_LFS_LARGEFILE) || defined(HAVE_64_BIT_IO)
#define POSIX_HAVE_64_BIT_IO
#define CVMioOpen		CVMioOpen
#define CVMioSeek		CVMioSeek
#define CVMioSetLength		CVMioSetLength
#define CVMioAvailable		CVMioAvailable
#define CVMioFileSizeFD		CVMioFileSizeFD
#endif

#define POSIX_HAVE_FSYNC
#define POSIX_HAVE_FTRUNCATE

/* Define the functions we will override */
#define CVMioRead		CVMioRead
#define CVMioClose		CVMioClose

#include "porting/posix/io.h"

void linuxIoInit(void);
void LINUXioEnqueue(CVMThreadID *t);
void LINUXioDequeue(CVMThreadID *t);

#endif /* _LINUX_IO_MD_H */
