/*
 * @(#)net_md.c	1.2 00/11/07
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#include "javavm/include/porting/net.h"
#include "javavm/include/porting/sync.h"
#include "javavm/include/porting/threads.h"
#include <stdio.h>

#include "javavm/include/io_md.h"

CVMInt32
CVMnetConnect(CVMInt32 fd, struct sockaddr *him, CVMInt32 len)
{
    CVMInt32 result;
    CVMThreadID *self = CVMthreadSelf();
    self->fd = fd;
    LINUXioEnqueue(self);
    result = POSIXnetConnect(fd, him, len);
    LINUXioDequeue(self);
    return result;
}

CVMInt32
CVMnetAccept(CVMInt32 fd, struct sockaddr *him, CVMInt32 *len)
{
    CVMInt32 result;
    CVMThreadID *self = CVMthreadSelf();
    self->fd = fd;
    LINUXioEnqueue(self);
    result = POSIXnetAccept(fd, him, len);
    LINUXioDequeue(self);
    return result;
}

CVMInt32
CVMnetSendTo(CVMInt32 fd, char *buf, CVMInt32 len, CVMInt32 flags,
	     struct sockaddr *to, CVMInt32 tolen)
{
    CVMInt32 result;
    CVMThreadID *self = CVMthreadSelf();
    self->fd = fd;
    LINUXioEnqueue(self);
    result = POSIXnetSendTo(fd, buf, len, flags, to, tolen);
    LINUXioDequeue(self);
    return result;
}

CVMInt32
CVMnetRecvFrom(CVMInt32 fd, char *buf, CVMInt32 nBytes,
	       CVMInt32 flags, struct sockaddr *from,
	       CVMInt32 *fromlen)
{
    CVMInt32 result;
    CVMThreadID *self = CVMthreadSelf();
    self->fd = fd;
    LINUXioEnqueue(self);
    result = POSIXnetRecvFrom(fd, buf, nBytes, flags, from, fromlen);
    LINUXioDequeue(self);
    return result;
}

CVMInt32
CVMnetRecv(CVMInt32 fd, char *buf, CVMInt32 nBytes,
	   CVMInt32 flags)
{
    CVMInt32 result;
    CVMThreadID *self = CVMthreadSelf();
    self->fd = fd;
    LINUXioEnqueue(self);
    result = POSIXnetRecv(fd, buf, nBytes, flags);
    LINUXioDequeue(self);
    return result;
}

CVMInt32
CVMnetSend(CVMInt32 fd, char *buf, CVMInt32 nBytes,
	   CVMInt32 flags)
{
    CVMInt32 result;
    CVMThreadID *self = CVMthreadSelf();
    self->fd = fd;
    LINUXioEnqueue(self);
    result = POSIXnetSend(fd, buf, nBytes, flags);
    LINUXioDequeue(self);
    return result;
}

CVMInt32
CVMnetTimeout(CVMInt32 fd, CVMInt32 timeout)
{
    CVMInt32 result;
    CVMThreadID *self = CVMthreadSelf();
    self->fd = fd;
    LINUXioEnqueue(self);
    result = POSIXnetTimeout(fd, timeout);
    LINUXioDequeue(self);
    return result;
}

void
linuxNetInit(void)
{
}
