/*
 * -----------------------------------------------------------------
 * AsyncEvent.c :
 *
 * Copyright (C) 2001 TimeSys Corporation, All Rights Reserved.
 *
 * This software is subject to the terms and conditions of the
 * accompanying Common Public License in file CPLicense.  Your use
 * of this software indicates your acceptance of these terms.
 * -----------------------------------------------------------------
 */


#include "AsyncEvent.h"
#include "javax_realtime_AsyncEvent.h"
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <signal.h>


/* A boundEvent array element is NULL if no AsyncEvent is bound to */
/* the signal index. It is defined in AsyncEvent.h */
int boundEvent[N_HAPPS];

JNIEXPORT void JNICALL Java_javax_realtime_AsyncEvent_initEvents
  (JNIEnv* env, jobject this)
{
  int i;
  //  printf("initializing Event\n");
  for(i=0;i<N_HAPPS;i++)
    boundEvent[i]=0;
}

/* install the AsyncEvent in the event array */
/* private native void installSigh(int signum) */
JNIEXPORT void JNICALL Java_javax_realtime_AsyncEvent_installEvent
  (JNIEnv* env, jobject this, jint jsignum)
{
  printf("installing Event %d\n",jsignum);
  boundEvent[jsignum]++;
  return;
}

JNIEXPORT void JNICALL Java_javax_realtime_AsyncEvent_uninstallEvent
  (JNIEnv* env, jobject this, jint jsignum)
{
  printf("UNinstalling Event\n");
  boundEvent[jsignum]--;
  return;
}
