/*
 * -----------------------------------------------------------------
 * SizeEstimator.c : Used for estimating the size of java objects.
 *
 * Copyright (C) 2001 TimeSys Corporation, All Rights Reserved.
 *
 * This software is subject to the terms and conditions of the
 * accompanying Common Public License in file CPLicense.  Your use
 * of this software indicates your acceptance of these terms.
 * -----------------------------------------------------------------
 */

//#include <jni.h>
#include "javax_realtime_SizeEstimator.h"
#include "javavm/include/mem_registry.h"
#include "javavm/include/directmem.h"
#include "javavm/include/interpreter.h"
#include "javavm/include/utils.h"

/*
 * Class:     javax_realtime_SizeEstimator 
 * Method:    sizeOf
 * Signature: (Ljava/lang/Class;)I
 */
JNIEXPORT jint JNICALL Java_javax_realtime_SizeEstimator_sizeOf
  (JNIEnv *env, jobject thisObj, jclass objClazz)
{
	jlong size = 0;
	CVMExecEnv *ee = CVMjniEnv2ExecEnv(env);
	CVMD_gcUnsafeExec(ee, {
				CVMClassBlock *cb = CVMgcUnsafeClassRef2ClassBlock(ee, objClazz);
				size = CVMcbInstanceSize(cb);
		});

    return size;
}
