import java.io.*;

public class Pipe
{
	PipedInputStream pin;
	PipedOutputStream pout;
	
	PipedInputStream noheap_pin;
	PipedOutputStream noheap_pout;

	static Pipe singleToneObj = null;
	
	private Pipe()
	{
		try{
			pout = new PipedOutputStream();
			pin = new PipedInputStream(pout);
			
			noheap_pout = new PipedOutputStream();
			noheap_pin = new PipedInputStream(noheap_pout);
			//pin.connect(pout);
		}catch(Exception e) {
			System.err.println("err in pipedinput/output/connect");
		}
	}

	public static Pipe getInstance()
	{
		if(singleToneObj == null)
			singleToneObj = new Pipe();
		return singleToneObj;
	}

	public PipedInputStream getSimplePipeIn()
	{
		return pin;
	}
	
	public PipedOutputStream getSimplePipeOut()
	{
		return pout;
	}

	public PipedInputStream getNoHeapPipeIn()
	{
		return noheap_pin;
	}

	public PipedOutputStream getNoHeapPipeOut()
	{
		return noheap_pout;
	}

	public int pipe_read()
	{
		int ret;
		try{
			ret = pin.read();
		}catch(IOException ioe){
			System.err.println("err in pipe reading");
			ret = -1;
		}
		return ret;
	}

	public void pipe_write(int b)
	{
		try {
			pout.write(b);
		} catch(IOException ioe) {
			System.err.println("err in pipe writing");
		}
	}

	public void pipe_flush()
	{
		try {
			pout.flush();
		}catch(IOException ioe) {
			System.err.println("err in flushing output pipe");
		}
	}

	public int noheappipe_read()
	{
		int ret;
		try{
			ret = noheap_pin.read();
		}catch(IOException ioe){
			System.err.println("err in pipe reading");
			ret = -1;
		}
		return ret;
	}

	public void noheappipe_write(int b)
	{
		try {
			noheap_pout.write(b);
		} catch(IOException ioe) {
			System.err.println("err in pipe writing");
		}
	}

	public void noheappipe_flush()
	{
		try {
			noheap_pout.flush();
		}catch(IOException ioe) {
			System.err.println("err in flushing output pipe");
		}
	}

}
