import javax.realtime.*;
import java.util.Vector;
import java.io.*;

/**
 * This is a test program that checks if a NoHeapRealtimeThread can reference 
 * an object in heap. The program MUST result in an IllegalAssignmentError
 * being thrown.
 * 
 * @author Pratik Solanki.
 */
public class BadNHRT extends NoHeapRealtimeThread
{
    Vector v;
    MyObject obj;
   
    public BadNHRT()
    {
        //super(null, ImmortalMemory.instance());
        super(null, null, null, ImmortalMemory.instance(), null, null);
        
    }
    
    public static void main(String[] args) throws Exception
    {
        
        try
        {
            BadNHRT nhrt = (BadNHRT) ImmortalMemory.instance().newInstance(Class.forName("BadNHRT"));
            nhrt.v = new Vector();
            nhrt.obj = new MyObject();
            FileOutputStream fdErr = new FileOutputStream(FileDescriptor.err);
            PrintStream p = new PrintStream(new BufferedOutputStream(fdErr, 128), true);
            System.out.println("*****");
            System.out.println("This is a test program that checks if a NoHeapRealtimeThread can reference an object in heap.\nThe program MUST result in an IllegalAssignmentError being thrown.");
            System.out.println("*****");
            nhrt.start();
            Thread.sleep(5000);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
            
    }

    public void run()
    {
        System.out.println("Bad NHRT Thread started"); 
        try
        {
            HeapMemory h = HeapMemory.instance();
            // v = (Vector) h.newInstance(Vector.class);
            obj = (MyObject) h.newInstance(MyObject.class);
            System.out.println("Managed to complete the illegal assignment!!!!!");
        }
        catch(Throwable e)
        {
            System.out.println("Exception thrown!");
            //System.out.println("It is: " + e);
            e.printStackTrace();
            //try
            //{
            //FileOutputStream fdErr = new FileOutputStream("t");
            //PrintStream p = new PrintStream(new BufferedOutputStream(fdErr, 128), true);
            //p.println("Exception thrown in BadNHRT");
            //}catch(Exception ex) {}
            
        }
        System.out.println("Exiting thread!");
    }
    
}

class MyObject
{
}
