import javax.realtime.*;

public class CycleAcrossThreadsTest extends RealtimeThread
{
    private ScopedMemory saved=null;
    
    public CycleAcrossThreadsTest(ScopedMemory s1, ScopedMemory s2)
    {
        super(null, null, null, s1, null, null);
        saved = s2;
    }
    
    public static void main(String[] args)
    {
        System.out.println("\nThis test checks for cycles across threads\n" +
                            "It tries to spawn rt1 that enters s1 and then s2 and\n" +
                            "then rt2 that enters s2 and then s1.\n" + 
                            "One of them should fail.\n");
        
        ScopedMemory s1 = new LTMemory(1024*16, 1024*16);
        ScopedMemory s2 = new LTMemory(1024*16, 1024*16);
        
        CycleAcrossThreadsTest rt1 = new CycleAcrossThreadsTest(s1, s2);
        CycleAcrossThreadsTest rt2 = new CycleAcrossThreadsTest(s2, s1);
        rt1.start();
        try
        {
            Thread.sleep(500);
        }
        catch(InterruptedException e) {}
        rt2.start();
    }

    public void run()
    {
        saved.enter(new Runnable() 
            {
                public void run()
                {
                    System.out.println("Printing stack");
                    MemStack.printStack();
                    try
                    {
                        Thread.sleep(2000);
                    }
                    catch(InterruptedException e) {}
                }
            });
    }
}
