import javax.realtime.*;

public class EnteringSameScopeTest extends RealtimeThread
{
    private ScopedMemory saved;
    
    public EnteringSameScopeTest(ScopedMemory s1, ScopedMemory s2)
    {
        super(null, null, null, s1, null, null);
        saved = s2;
    }
    
    public static void main(String[] args)
    {
        System.out.println("\nThis test tries to create two threads that both enter the\n" +
                          "same memory areas in the same sequence. It should succeed\n" +
                          "because the entering is legal\n");
        
        ScopedMemory s1 = new LTMemory(1024*16, 1024*16);
        ScopedMemory s2 = new LTMemory(1024*16, 1024*16);    
        RealtimeThread rt1 = new EnteringSameScopeTest(s1, s2);
        RealtimeThread rt2 = new EnteringSameScopeTest(s1, s2);
        rt1.start();
        rt2.start();
    }

    public void run()
    {
        saved.enter(new Runnable()
            {
                public void run()
                {
                    System.out.println("Printing stack");
                    MemStack.printStack();
                    try
                    {
                        // This is to ensure that the first thread does not exit before 
                        // the 2nd one has had a chance to come in
                        Thread.sleep(1000);
                    }
                    catch(Exception e)
                    {
                        e.printStackTrace();
                    }
                }
            });
    }
}
