import javax.realtime.*;

public class StaticInitializerTest extends RealtimeThread
{
    public static int memsize = 1024*16;
    
    public StaticInitializerTest()
    {
        super(null, null, null, HeapMemory.instance(), null, null);
    }

    public static void main(String[] args)
    {
        System.out.println("\nThis test enters 3 scopes, creates a new object which\n" + 
                            "has a static block that prints the memory stack and\n" +
                            "enters a scope itself\n");
        StaticInitializerTest st = new StaticInitializerTest();
        st.start();
    }

    public void run()
    {
        ScopedMemory s1 = new LTMemory(memsize, memsize);
        s1.enter( new Runnable() {
                public void run()
                {
                    ScopedMemory s2 = new LTMemory(memsize, memsize);
                    s2.enter(new Runnable() {
                        public void run()
                        {
                            ScopedMemory s3 = new LTMemory(memsize, memsize);
                            s3.enter(new Runnable() {
                                public void run()
                                {
                                    System.out.println("Stack after entering 3 memory areas");
                                    MemStack.printStack();
                                    WonderfulStatics ws = new WonderfulStatics();
                                    System.out.println("Stack after creation of object (and static initialization");
                                    MemStack.printStack();
                                }
                            });
                        }
                    });
                }
        });
        System.out.println("Test finished!");
    }
}
