
import javax.realtime.*;

public class UTImmortalMemory
{
	public static void main(String[] args)
	{
		UTImmortalMemory u = new UTImmortalMemory();
		u.runTest();
		
		System.gc();
		System.runFinalization();
		System.out.println("Finished everything");
		System.exit(0);
	}

	public void runTest()
	{
		try
		{
				ImmortalMemory immortal = ImmortalMemory.instance();
				for(int i=0; i<10; i++)
				{
					ImmortalObject obj1 = new ImmortalObject();
					ImmortalObject obj2 = (ImmortalObject) immortal.newInstance(obj1.getClass());
					System.out.println("heap object: " + obj1 + " and it is allocated in " + MemoryArea.getMemoryArea(obj1));
					System.out.println("immortal object: " + obj2);// + " and it is allocated in " + MemoryArea.getMemoryArea(obj2));
				}
				System.out.println("Finished creation");
						
				System.out.println("Immortal mem left = " + immortal.memoryRemaining());
				System.out.println("Immortal mem consumed = " + immortal.memoryConsumed());
		

		}
		catch(Exception e)
		{
			e.printStackTrace(); 
		}
	}
	
	protected void finalize()
	{
		System.out.println("Reached finalize in UTImmortalMemory");
	}
}

class T
{
	protected void finalize()
	{
		System.out.println("T.finalize");
	}
}
