
import javax.realtime.*;

public class UTRawMemoryAccess
{
    public static void main(String[] args)
    {
	if(args.length < 2)
	    {
		System.out.println("usage: java TestRaw <memory address> <size>");
		return;		
	    }	
	
	try
	    {	
		RawMemoryAccess rwm = RawMemoryAccess.create(null, Long.parseLong(args[0]), Integer.parseInt(args[1]));
		
		/* Test 1 
		 * Writing and reading a byte
		 */
		System.out.print("Test 1 - writing and reading a byte...");
		rwm.setByte(0L, (byte)112);
		if(rwm.getByte(0L) == 112)
		    System.out.println("passed");
		else
		    System.out.println("failed");
		
		
		byte[] bytes = new byte[10];
		for(int i=0; i<10; i++)
		    {
			bytes[i] = (byte) (i+50);
		    }
		
		rwm.setBytes(5L, bytes, 0, 5);
		rwm.getBytes(5L, bytes, 5, 5);

		for(int j=0; j<10; j++)
		    {
			System.out.println("byte is " + bytes[j]);
		    }

		
	    }
	catch(Exception e)
	    {
		e.printStackTrace();
	    }
    }
}
