//package realtime;

import javax.realtime.*;

public class UTRawMemoryFloatAccess
{
    public static void main(String[] args)
    {
	if(args.length < 2)
	    {
		System.out.println("usage: java TestRaw <memory address> <size>");
		return;		
	    }	
	
	try
	    {	
		RawMemoryFloatAccess rwm = RawMemoryFloatAccess.createFloatAccess(null, Long.parseLong(args[0]), Integer.parseInt(args[1]));
		
		/* Test 1 
		 * Writing and reading a byte
		 */
		System.out.print("Test 1 - writing and reading a byte...");
		rwm.setDouble(0L, (double)11.2);
		if(rwm.getDouble(0L) == 11.2)
		    System.out.println("passed");
		else
		    System.out.println("failed");
		
		
		float[] floats = new float[10];
		for(int i=0; i<10; i++)
		    {
			floats[i] = (float) ((float)i+50.5);
		    }
		
		rwm.setFloats(5L, floats, 0, 5);
		rwm.getFloats(5L, floats, 5, 5);

		for(int j=0; j<10; j++)
		    {
			System.out.println("float is " + floats[j]);
		    }

		
	    }
	catch(Exception e)
	    {
		e.printStackTrace();
	    }
    }
}
