/* MemTest - This class contains MemoryArea subtests 4-8 of the 
**           ImmortalMemoryTests that must be executed as Realtime threads.
*/

//package javax.realtime.calltests;

/*
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 2000  All Rights Reserved
 */

import javax.realtime.*;


public class MemTest implements Runnable
{

    ImmortalMemory i1;

    public MemTest(ImmortalMemory one)
    {
	this.i1=one;
    }
	
    public void run() 
    {
	String str1 = new String("Hello");

	/* Subtest 4	
	** Method "public static MemoryArea getMemoryArea(java.lang.Object 
	** object)"
	*/
	Tests.increment();
	try {
	    System.out.println("MemTest: getMemoryArea(Object)");
	    MemoryArea ma;
	    ma = MemoryArea.getMemoryArea(str1);
	    if (!(ma instanceof MemoryArea))
		throw new Exception("Return object is not instanceof MemoryArea");
	} catch (Exception e) {
	    System.out.println("MemTest: getMemoryArea(Object) failed");
	    Tests.fail("MemoryArea.getMemoryArea()",e);
	}

	/* Subtest 5
	** Method "public long size()"
	*/
	Tests.increment();
	try {
	    System.out.println("MemTest: size()");
	    MemoryArea ma;
	    ma = MemoryArea.getMemoryArea(str1);
	    long size = ma.size();
	    if (size < 0)
		throw new Exception("Memory size is less than 0");
	} catch (Exception e) {
	    System.out.println("MemTest: size() failed");
	    Tests.fail("ma.size()",e);
	}

	/* Subtest 6
	** Method "public long memoryConsumed()"
	*/
	Tests.increment();
	try { 
	    System.out.println("MemTest: memoryConsumed()");
	    MemoryArea ma;
	    ma = MemoryArea.getMemoryArea(str1);
	    long consumed = ma.memoryConsumed();
	    if (consumed < 0)
		throw new Exception("Memory consumed is less than 0");
	} catch (Exception e) {
	    System.out.println("MemTest: memoryConsumed() failed");
	    Tests.fail("ma.memoryConsumed()", e);
	}

	/* Subtest 7
	** Method "public long memoryRemaining()"
	*/
	Tests.increment();
	try {
	    System.out.println("MemTest: memoryRemaining()");
	    MemoryArea ma;
	    ma = MemoryArea.getMemoryArea(str1);
	    long remaining = ma.memoryRemaining();
	    if (remaining < 0)
		throw new Exception("Memory remaining is less than 0");
	} catch (Exception e) {
	    System.out.println("MemTest: memoryRemaining() failed");
	    Tests.fail("ma.memoryRemaining()", e);
	}

	/* Subtest 8
	** public void enter(java.lang.Runnable logic)
	*/
	Tests.increment();
	try {
	    System.out.println("MemTest: enter(Runnable)");
	    i1.enter(new Runnable() {
		    public void run()
		    {
			String str2 = new String("Here");
		    }
		} );
	} catch (Exception e) {
	    System.out.println("MemTest: enter(Runnable) failed");
	    Tests.fail("i1.enter()",e);
	}	
    }
}
