/* MyRTThread - This class is a subclass of RealtimeThread and is used in
**              subtest 14 of the RealtimeThreadTest to provide a realtime
** 		upon which to call interrupt().
*/

import javax.realtime.*;

public class MyRTThread extends RealtimeThread 
{
    private Semaphore semaphore;

    public MyRTThread(Semaphore shared_semaphore) 
    {
	System.out.println("MyRTThread: MyRTThread(Semaphore)");
	semaphore = shared_semaphore;
    }
	
    public void run() 
    {
	try {
	    System.out.println("MyRTThread: run()");
	    semaphore.sNotify();
	    Thread.sleep(60000);
	    System.out.println("MyRTThread: MyRTThread waking up");
	    System.out.println("MyRTThread interrupt() did not throw an "+
			       "InterruptedException inside of MyRTThread as "+
			       "expected, and failed");
	    Tests.threadFail();
	} catch (Exception e) {
	    if (! (e instanceof InterruptedException)) {
		System.out.println("MyRTThread: interrupt() threw an "+
				   "exception in MyRTThread other than "+
				   "InterruptedException");
		e.printStackTrace();
		Tests.threadFail();
	    }
	    else {
		System.out.println("MyRTThread: received "+
				   "InterruptedException as expected");
	    }
	}
	
    }
}
