//package javax.realtime.calltests;

/*
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 2000  All Rights Reserved
 */


/* 				RealtimeSecurityTest

Subtest 1:
	"public RealtimeSecurity()"

Subtest 2:
	"public void checkAccessPhysical()"

Subtest 3:
	"public void checkAccessPhysicalRange(long base, long size)

Subtest 4:
	"public void checkAccessPhysicalRange(long base, long size)
	** SecurityException is expected

Subtest 5:
	"public void checkSetFactory()"

Subtest 6:
	"public void checkSetScheduler()"
*/

import javax.realtime.*;

public class RealtimeSecurityTest 
{
    public static void run() 
    {
	RealtimeSecurity rs = null;
	Object o = null;

	Tests.newTest("RealtimeSecurityTest");

	/* Subtest 1:
	** Constructor "public RealtimeSecurity()"
	*/
	Tests.increment();
	try {
	    System.out.println("RealtimeSecurityTest: RealtimeSecurity()");
	    rs = new RealtimeSecurity();
	    if( !(rs instanceof RealtimeSecurity) )
		throw new Exception("Return object is not instance of "+
				    "RealtimeSecurity");
	} catch (Exception e) {
	    System.out.println("RealtimeSecurityTest: RealtimeSecurity() "+
			       "failed");
	    Tests.fail("new RealtimeSecurity()",e);
	}

	/* Subtest 2:
	** Method "public void checkAccessPhysical()"
	*/
	Tests.increment();
	try {
	    System.out.println("RealtimeSecurityTest: checkAccessPhysical()");
	    rs = new RealtimeSecurity();
	    rs.checkAccessPhysical();
	} catch (Exception e) {
	    System.out.println("RealtimeSecurityTest: checkAccessPhysical() "+
			       "failed");
	    Tests.fail("rt.checkAccessPhysical()",e);
	}

	/* Subtest 3:
	** Method "public void checkAccessPhysicalRange(long base, long size)
	*/
	Tests.increment();
	try {
	    System.out.println("RealtimeSecurityTest: checkAccessPhysical"+
			       "Range(long,long)");
	    rs = new RealtimeSecurity();
	    rs.checkAccessPhysicalRange(100L, 100L);
	} catch (Exception e) {
	    System.out.println("RealtimeSecurityTest: checkAccessPhysical"+
			       "Range(long,long) failed");
	    Tests.fail("rt.checkAccessPhysicalRange(100L,100L)",e);
	}

	/* Subtest 4:
	** Method "public void checkAccessPhysicalRange(long base, long size)
	** SecurityException is expected
	*/
	Tests.increment();
	try {
	    System.out.println("RealtimeSecurityTest: checkAccessPhysical"+
			       "Range(long,long)");
	    rs = new RealtimeSecurity();
	    rs.checkAccessPhysicalRange(0,999999999);
	    Tests.fail("rs.checkAccessPhysicalRange(0,999999999) did not "+
		       "throw expected SecurityException");
	} catch (Exception e) {
	    System.out.println("RealtimeSecurityTest: checkAccessPhysical"+
			       "Range(long,long) failed");
	    if (! (e instanceof SecurityException))
		Tests.fail("rt.checkAccessPhysicalRange(0,999999999) threw "+
			   "an exception other than SecurityException",e);
	}

	/* Subtest 5:
	** Method "public void checkSetFactory()"
	*/
	Tests.increment();
	try {
	    System.out.println("RealtimeSecurityTest: checkSetFactory()");
	    rs = new RealtimeSecurity();
	    rs.checkSetFactory();
	} catch (Exception e) {
	    System.out.println("RealtimeSecurityTest: checkSetFactory() "+
			       "failed");
	    Tests.fail("rs.checkSetFactory()",e);
	}

	/* Subtest 6:
	** Method "public void checkSetScheduler()"
	*/
	Tests.increment();
	try {
	    System.out.println("RealtimeSecurityTest: checkSetScheduler()");
	    rs = new RealtimeSecurity();
	    rs.checkSetScheduler();
	} catch (Exception e) {
	    System.out.println("RealtimeSecurityTest: checkSetScheduler() "+
			       "failed");
	    Tests.fail("rs.checkSetScheduler()",e);
	}

	Tests.printSubTestReportTotals("RealtimeSecurityTest");

    }
}
