//package javax.realtime.calltests;

/*
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 2000  All Rights Reserved
 */


/*				RelativeTimeTest
 
Subtest 1:
	"public RelativeTime()"

Subtest 2:
	"public RelativeTime(long millis, int nanos)"

Subtest 3
	"public RelativeTime(Relative time)"

Subtest 4
	"public RelativeTime add(long millis, int nanos)"

Subtest 5
	"public RelativeTime add(long millis, int nanos, RelativeTime 
	destination)"

Subtest 6
	"public RelativeTime add(long millis, int nanos, RelativeTime 
	destination)" where destination is null

Subtest 7
	"public RelativeTime add(RelativeTime time)"

Subtest 8
	"public RelativeTime add(RelativeTime time, RelativeTime destination)
	
Subtest 8
	"public RelativeTime add(RelativeTime time, RelativeTime destination) 
	where the destination is null
	
Subtest 9
	"public void addInterarrivalTo(AbsoluteTime destination)"

Subtest 10:
	"public RelativeTime getInterarrivalTime(RelativeTime destination)"
	
Subtest 11:
	"public RelativeTime getInterarrivalTime(RelativeTime destination)" 
	where destination is null
	
Subtest 12
	"public final RelativeTime subtract(RelativeTime time)"

Subtest 13
	"public RelativeTime subtract(RelativeTime time, RelativeTime 
	destination)"
	
Subtest 14
	"public RelativeTime subtract(RelativeTime time, RelativeTime 
	destination)" where destination is null
	
Subtest 15
	"public java.lang.String toString()"

Subtest 16 
	"public AbsoluteTime absolute(Clock clock, AbsoluteTime destination)

Subtest 17
	"public AbsoluteTime absolute(Clock clock, AbsoluteTime destination) 
	where clock and destination are both null
*/


import javax.realtime.*;
import java.util.*;

public class RelativeTimeTest 
{
    public static void run() 
    {
	RelativeTime rt = null;
	Object o = null;
	Tests.newTest("RelativeTimeTest");

	/* Subtest 1:
	** Constructor "public RelativeTime()"
	*/
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: RelativeTime()");
	    rt = new RelativeTime();
	    if( !(rt instanceof RelativeTime && rt instanceof HighResolutionTime) )
		throw new Exception("Return object is not instanceof RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: RelativeTime() failed");
	    Tests.fail("new RelativeTimeT()",e);
	}

	/* Subtest 2:
	** Constructor "public RelativeTime(long millis, int nanos)"
	*/
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: RelativeTime(long,int)");
	    rt = new RelativeTime(100L,100);
	    if( !(rt instanceof RelativeTime && rt instanceof 
		  HighResolutionTime) )
		throw new Exception("Return object is not instanceof "+
				    "RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: RelativeTime(long,int) "+
			       "failed");
	    Tests.fail("new RelativeTime(100L,100)",e);
	}

	/* Subtest 3
	** Constructor "public RelativeTime(Relative time)"
	*/
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: RelativeTime(RelativeTime)");
	    rt = new RelativeTime(100L,100);
	    RelativeTime newrt = new RelativeTime(rt);
	    if( !(newrt instanceof RelativeTime && newrt instanceof HighResolutionTime) )
		throw new Exception("Return object is not instanceof RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: RelativeTime(RelativeTime) "+
			       "failed");
	    Tests.fail("new RelativeTime(rt)",e);
	}

	/* Subtest 4
	** Method "public RelativeTime add(long millis, int nanos)"
	*/
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: add(long,int)");
	    long millis = 10223;
	    int nanos = 100;
	    o = rt.add(millis, nanos);
	    if( !(o instanceof RelativeTime && o instanceof 
		  HighResolutionTime) )
		throw new Exception("Return object is not instanceof "+
				    "RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: add(long,int)");
	    Tests.fail("rt.add(millis,nanos)",e);
	}

	/* Subtest 5
	** Method "public RelativeTime add(long millis, int nanos, 
	** RelativeTime destination)"
	*/
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: add(long,int,RelativeTime)");
	    long millis = 10223;
	    int nanos = 100;
	    o = rt.add(millis, nanos, rt);
	    if( !(o instanceof RelativeTime && o instanceof 
		  HighResolutionTime) )
		throw new Exception("Return object is not instanceof "+
				    "RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: add(long,int,RelativeTime) "+
			       "failed");
	    Tests.fail("rt.add(millis,nanos,rt)",e);
	}
		
	/* Subtest 6
	** Method "public RelativeTime add(long millis, int nanos, 
	** RelativeTime destination)" where destination is null
	*/
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: add(long,int,null)");
	    long millis = 10223;
	    int nanos = 100;
	    o = rt.add(millis, nanos, null);
	    if( !(o instanceof RelativeTime && o instanceof 
		  HighResolutionTime) )
		throw new Exception("Return object is not instanceof "+
				    "RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: add(long,int,null) failed");
	    Tests.fail("rt.add(millis,nanos,null)",e);
	}

	/* Subtest 7
	** Method "public RelativeTime add(RelativeTime time)"
	*/
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: add(RelativeTime)");
	    RelativeTime nrt = new RelativeTime(100L,100);
	    o = rt.add(nrt);
	    if( !(o instanceof RelativeTime && o instanceof 
		  HighResolutionTime) )
		throw new Exception("Return object is not instanceof "+
				    "RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: add(RelativeTime) failed");
	    Tests.fail("rt.add(nrt)",e);
	}
	
	/* Subtest 8
	** Method "public RelativeTime add(RelativeTime time, RelativeTime 
	** destination)
	*/	
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: add(RelativeTime,"+
			       "RelativeTime)");
	    RelativeTime nrt = new RelativeTime(100L,100);
	    o = rt.add(nrt, rt);
	    if( !(o instanceof RelativeTime && o instanceof 
		  HighResolutionTime) )
		throw new Exception("Return object is not instanceof "+
				    "RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: add(RelativeTime,"+
			       "RelativeTime) failed");
	    Tests.fail("rt.add(nrt,rt)",e);
	}
		
	/* Subtest 8
	** Method "public RelativeTime add(RelativeTime time, 
	** RelativeTime destination) where the destination is null
	*/	
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: add(RelativeTime,null)");
	    RelativeTime nrt = new RelativeTime(100L,100);
	    o = rt.add(nrt, null);
	    if( !(o instanceof RelativeTime && o instanceof 
		  HighResolutionTime) )
		throw new Exception("Return object is not instanceof "+
				    "RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: add(RelativeTime,null) "+
			       "failed");
	    Tests.fail("rt.add(nrt,null)",e);
	}

	/* Subtest 9
	** Method "public void addInterarrivalTo(AbsoluteTime destination)"
	*/
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: addInterarrivalTo("+
			       "AbsoluteTime)");
	    AbsoluteTime dest = new AbsoluteTime(0,0);
	    rt.addInterarrivalTo(dest);
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: addInterarrivalTo("+
			       "AbsoluteTime) failed");
	    Tests.fail("rt.addInterarrival(dest)",e);
	}
	
	/* Subtest 10:
	** Method "public RelativeTime getInterarrivalTime(RelativeTime 
	** destination)"
	*/	
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: getInterarrivalTime("+
			       "RelativeTime)");
	    o = rt.getInterarrivalTime(rt);
	    if( !(o instanceof RelativeTime && o instanceof 
		  HighResolutionTime) )
		throw new Exception("Return object is not instanceof "+
				    "RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: getInterarrivalTime("+
			       "RelativeTime) failed");
	    Tests.fail("rt.getInterarrivalTime(rt)",e);
	}

	/* Subtest 11:
	** Method "public RelativeTime getInterarrivalTime(RelativeTime 
	** destination)" where destination is null
	*/	
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: getInterarrivalTime(null)");
	    o = rt.getInterarrivalTime(null);
	    if( !(o instanceof RelativeTime && o instanceof 
		  HighResolutionTime) )
		throw new Exception("Return object is not instanceof "+
				    "RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: getInterarrivalTime(null) "+
			       "failed");
	    Tests.fail("rt.getInterarrivalTime(null)",e);
	}

	/* Subtest 12
	** Method "public final RelativeTime subtract(RelativeTime time)"
	*/
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: subtract(RelativeTime)");
	    rt = new RelativeTime(1000L,100);
	    RelativeTime srt = new RelativeTime(0L,100);
	    o = rt.subtract(srt);
	    if( !(o instanceof RelativeTime && o instanceof 
		  HighResolutionTime) )
		throw new Exception("Return object is not instanceof "+
				    "RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: subtract(RelativeTime) "+
			       "failed");
	    Tests.fail("rt.subtract(srt)",e);
	}
	
	/* Subtest 13
	** Method "public RelativeTime subtract(RelativeTime time, 
	** RelativeTime destination)"
	*/	
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: subtract(RelativeTime,"+
			       "RelativeTime)");
	    RelativeTime drt = new RelativeTime();
	    rt = new RelativeTime(1000L,100);
	    RelativeTime srt = new RelativeTime(0L,200);
	    o = rt.subtract(rt, drt);
	    if( !(o instanceof RelativeTime && o instanceof 
		  HighResolutionTime) )
		throw new Exception("Return object is not instanceof "+
				    "RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: subtract(RelativeTime,"+
			       "RelativeTime) failed");
	    Tests.fail("rt.subtract(rt,drt)",e);
	}

	/* Subtest 14
	** Method "public RelativeTime subtract(RelativeTime time, 
	** RelativeTime destination)" where destination is null
	*/	
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: subtract(RelativeTime,"+
			       "null)");
	    rt = new RelativeTime(1000L,100);
	    RelativeTime srt = new RelativeTime(0L,200);
	    o = rt.subtract(rt, null);
	    if( !(o instanceof RelativeTime && o instanceof 
		  HighResolutionTime) )
		throw new Exception("Return object is not instanceof "+
				    "RelativeTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: subtract(RelativeTime,"+
			       "null) failed");
	    Tests.fail("rt.subtract(rt,null)",e);
	}

	/* Subtest 15
	** method "public java.lang.String toString()"
	*/
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: toString()");
	    String s;
	    s = rt.toString();
	    if( s.length() == 0 )
		throw new Exception("String is empty");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: toString() failed");
	    Tests.fail("rt.toString()",e);
	}
		
	/* Subtest 16 
	** method "public AbsoluteTime absolute(Clock clock, AbsoluteTime 
	** destination)
	*/
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: absolute(Clock,"+
			       "AbsoluteTime)");
	    AbsoluteTime dat = new AbsoluteTime();
	    Clock clock = Clock.getRealtimeClock();
	    o = rt.absolute(clock,dat);
	    if (! (o instanceof AbsoluteTime && o instanceof 
		   HighResolutionTime))
		throw new Exception("Return object is not instanceof "+
				    "AbsoluteTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: absolute(Clock,"+
			       "AbsoluteTime) failed");
	    Tests.fail("rt.absolute(clock, drt)",e);
	}

	/* Subtest 17
	** method "public AbsoluteTime absolute(Clock clock, AbsoluteTime 
	** destination) where clock and destination are both null
	*/
	Tests.increment();
	try {
	    System.out.println("RelativeTimeTest: absolute(null, null)");
	    o = rt.absolute(null, null);
	    if (! (o instanceof AbsoluteTime && o instanceof 
		   HighResolutionTime))
		throw new Exception("Return object is not instanceof "+
				    "AbsoluteTime nor HighResolutionTime");
	} catch (Exception e) {
	    System.out.println("RelativeTimeTest: absolute(null, null) "+
			       "failed");
	    Tests.fail("rt.absolute(null, null)",e);
	}

	Tests.printSubTestReportTotals("RelativeTimeTest");
    }
}
