//package javax.realtime.calltests;

/*
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 2000  All Rights Reserved
 */


/*				SporadicParametersTest
 
Subtest 1:
	"public SporadicParameters(RelativeTime minInterarrival,RelativeTime 
	cost, RelativeTime deadlin, AsyncEventHandler overrunHandler, 
	AsyncEventHandler missHandler)" where all values are null

Subtest 2:
	"public SporadicParameters(RelativeTime minInterarrival,RelativeTime 
	cost, RelativeTime deadlin, AsyncEventHandler overrunHandler, 
	AsyncEventHandler missHandler)"

Subtest 3:
	"public RelativeTime getMinimumInterarrival()"

Subtest 4:
	"public void setMinimumInterarrival(RelativeTime minimum)"
*/

import javax.realtime.*;

public class SporadicParametersTest 
{

    public static void run() 
    {
	SporadicParameters sp = null;
	Object o = null;
	RelativeTime minInterarrival = null;
	Tests.newTest("SporadicParametersTest");

	/* Subtest 1:
	** Constructor "public SporadicParameters(RelativeTime minInterarrival,
	** RelativeTime cost, RelativeTime deadlin, AsyncEventHandler 
	** overrunHandler, AsyncEventHandler missHandler)" where all values 
	** are null
	*/

	Tests.increment();
	try {
	    System.out.println("SporadicParametersTest: public Sporadic"+
			       "Parameters(null,null,null,null,null)");
	    RelativeTime cost = null;
	    RelativeTime deadline = null;
	    AsyncEventHandler overrunHandler = null;
	    AsyncEventHandler missHandler = null;
	    sp = new SporadicParameters(minInterarrival, cost, deadline, 
					overrunHandler, missHandler);
	    if( !(sp instanceof SporadicParameters && sp instanceof 
		  AperiodicParameters) )
		throw new Exception("Return object is not instanceof "+
				    "SporadicParameters nor Aperiodic"+
				    "Parameters");
	} catch (Exception e) {
	    System.out.println("SporadicParametersTest: public Sporadic"+
			       "Parameters(null,null,null,null,null) failed");
	    Tests.fail("new SporadicParameters(minInterarrival,cost,deadline,"+
		       "overrunHandler,missHandler",e);
	}

	/* Subtest 2:
	** Constructor "public SporadicParameters(RelativeTime minInterarrival,
	** RelativeTime cost, RelativeTime deadlin, AsyncEventHandler 
	** overrunHandler, AsyncEventHandler missHandler)"
	*/
	Tests.increment();
	try {
	    System.out.println("SporadicParametersTest: SporadicParameters("+
			       "RelativeTime,RelativeTime,RelativeTime,Async"+
			       "EventHandler,AsyncEventHandler)");
	    minInterarrival = new RelativeTime(200L,0);
	    RelativeTime cost = new RelativeTime(8000L,500);
	    RelativeTime deadline = new RelativeTime(200L,0);
	    AsyncEventHandler overrunHandler = new AEventHandler();
	    AsyncEventHandler missHandler = new AEventHandler();

	    sp = new SporadicParameters(minInterarrival, cost, deadline, 
					overrunHandler, missHandler);
	    if( !(sp instanceof SporadicParameters && sp instanceof 
		  AperiodicParameters) )
		throw new Exception("Return object is not instanceof Sporadic"+
				    "Parameters nor AperiodicParameters");
	} catch (Exception e) {
	    System.out.println("SporadicParametersTest: SporadicParameters("+
			       "RelativeTime,RelativeTime,RelativeTime,Async"+
			       "EventHandler,AsyncEventHandler) failed");
	    Tests.fail("new SporadicParameters(minInterarrival,cost,deadline,"+
		       "overrunHandler,missHandler",e);
	}
		
	/* Subtest 3:
	** Method "public RelativeTime getMinimumInterarrival()"
	*/
	Tests.increment();
	try {
	    System.out.println("SporadicParametersTest: getMinimum"+
			       "Interarrival()");
	    o = sp.getMinimumInterarrival();
	    if( !(o instanceof RelativeTime) )
		throw new Exception("Return object is not instanceof Relative"+
				    "Time");
	    RelativeTime rt = (RelativeTime)o;
	    if (!(rt.equals(minInterarrival)))
		throw new Exception("Unexpected Minimum Interarrival time "+
				    "received");
	} catch (Exception e) {
	    System.out.println("SporadicParametersTest: getMinimum"+
			       "Interarrival() failed");
	    Tests.fail("sp.getMiminumInterarrival()",e);
	}

	/* Subtest 4:
	** Method "public void setMinimumInterarrival(RelativeTime minimum)"
	*/
	Tests.increment();
	try {
	    System.out.println("SporadicParametersTest: setMinimum"+
			       "Interarrival(RelativeTime)");
	    RelativeTime rt = new RelativeTime(500L,0);
	    sp.setMinimumInterarrival(rt);
	    RelativeTime rt2 = sp.getMinimumInterarrival();
	    if (! (rt.equals(rt2)))
		throw new Exception("Minimum Interarrival time not set "+
				    "properly");
	} catch (Exception e) {
	    System.out.println("SporadicParametersTest: setMinimum"+
			       "Interarrival(RelativeTime) failed");
	    Tests.fail("sp.setMinimumInterarrival(rt)",e);
	}

	Tests.printSubTestReportTotals("SporadicParametersTest");
    }
}
