import java.util.*;

public class ThreadData {

    int type, id;

    Vector mem_data, object_data;
    int num_mem_data, num_obj_data;

    Thread thr;

    public ThreadData(int i_d) {
	id=i_d;
	num_mem_data=0;
	num_obj_data=0;
    }

    public void setThread(Thread t){
	thr=t;
    }

    public Thread getThread(){
	return thr;
    }

    public void setType(int t) { type=t; }

    public int getType() { return type; }

    public void dump(int caller) {

	System.out.println("-----Begin ThreadData Dump-----");

	System.out.print("type : ");
	switch(type) {

	case ThreadFactory.USER_THREAD :
	    System.out.print("Thread");
	    break;
	case ThreadFactory.RT_THREAD :
	    System.out.println("Realtime Thread");
	    break;
	case ThreadFactory.NHRT_THREAD :
	    System.out.println("NoHeapRealtime Thread");
	    break;
	}
	System.out.println(" id : "+id);
	
	if(caller != sanity_checker.MEMORY) {
	    System.out.println("MemAreas --- ");
	    for(int x=0; x<num_mem_data; x++) {
		((MemData)mem_data.elementAt(x)).dump(sanity_checker.THREAD);
	    }
	}

	if(caller != sanity_checker.OBJECT) {
	    System.out.println("Objects --- ");
	    for(int x=0; x<num_obj_data; x++) {
		((ObjectData)object_data.elementAt(x)).dump(
						    sanity_checker.THREAD);
	    }
	}

	System.out.println("-----End ThreadData Dump-----");

    }

    public void dump() { dump(-1); }

    public void addMemData(MemData md) {
	mem_data.addElement(md);
	num_mem_data++;
    }

    public void addObjectData(ObjectData od) {
	object_data.addElement(od);
	num_obj_data++;
    }

    public void removeMemData(MemData md) {
	for(int x=0; x<num_mem_data; x++) {
	    if(md.getId()==((MemData)mem_data.elementAt(x)).getId()) {
		mem_data.remove(x);
		num_mem_data--;
		return;
	    }
	} 
    }

    public void removeObjectData(ObjectData od) {
	for(int x=0; x<num_obj_data; x++) {
	    if(od.getId()==((ObjectData)object_data.elementAt(x)).getId()) {
		object_data.remove(x);
		num_obj_data--;
		return;
	    }
	} 
    }

    public int getId() {
	return id;
    }

}
