import java.io.*;
import java.lang.*;
import javax.realtime.*;
import com.timesys.*;

public class prioInheritance{

    public Integer monitor;

	public class simpleRTThread extends RealtimeThread
	{

	    private final int sampleSize = 3000;
	    private final int iterations = 50;
	    int cs =0;
	    int ncs = 0;

	    public simpleRTThread(SchedulingParameters scheduling,
			  ReleaseParameters release)
	    {
		super(scheduling, release);
	    }

	    public void run()
	    {
		int i,j, k, index = 0;
		int stage = 0;
		long [] sampleTime = new long[sampleSize];
		long [] sampleStage = new long[sampleSize];

		long startTime = System.currentTimeMillis();

		for (k=0;k<iterations;k++)
		    {
			/* Entering the Critical Section */
			System.out.println(getName()+": trying to enter cs");
			synchronized(monitor)
			    {
				System.out.println(getName()+": inside cs");
				stage = 2;
				for (i=0; i< 50; i++)
				    {
				/* dummy loop */
					for (j=0; j<99; j++)
					    ;
					
				/* timestamp */
					if (index < sampleSize)
					    {
						sampleTime[index]= System.currentTimeMillis();
						sampleStage[index] = stage;
						index ++;
					    }
				    }
			    }
			System.out.println(getName()+": outside cs");
			stage = 1;
			for (i=0; i< 10; i++)
			    {
				/* dummy loop */
				for (j=0; j<99; j++)
				    ;
				
				/* timestamp */
				if (index < sampleSize)
				    {
					sampleTime[index]= System.currentTimeMillis();
					sampleStage[index] = stage;
					index ++;
				    }
			    }
			waitForNextPeriod();
		    }

		/* writring down the file */ 
		try{
		    PrintWriter prn = new PrintWriter(new FileOutputStream(getName()));
		    for (i=0;i<sampleSize;i++)
			prn.println((sampleTime[i]-startTime)+"\t"+sampleStage[i]);
		    prn.close();
		}
		catch(Exception e)
		    {
			System.out.println(e);
		    }
		System.out.println(getName()+" Done!");
	    }
	}


	public static void main(String args[]){
		prioInheritance s = new prioInheritance();
		s.run();
	}

	public void run(){
	    monitor = new Integer(0);

	    //MonitorControl.setMonitorControl(monitor, new PriorityInheritance());

	    System.out.println("starting");
		simpleRTThread rtt, rtt1, rtt2;
		AbsoluteTime start = new AbsoluteTime(System.currentTimeMillis() + 2000,0);
		RelativeTime period = new RelativeTime(1000,0);
		RelativeTime period1 = new RelativeTime(2000,0);
		RelativeTime period2 = new RelativeTime(4000,0);
		RelativeTime deadline = new RelativeTime(1000,0);
		RelativeTime deadline1 = new RelativeTime(2000,0);
		RelativeTime deadline2 = new RelativeTime(4000,0);
		RelativeTime cost   = new RelativeTime(100,0);
		RelativeTime cost1   = new RelativeTime(100,0);
		
		PeriodicParameters sp = new PeriodicParameters(start, period, cost, deadline, null, null);
		PeriodicParameters sp1 = new PeriodicParameters(start, period1, cost1, deadline1, null, null);
		PeriodicParameters sp2 = new PeriodicParameters(start, period2, cost1, deadline2, null, null);

		try {
		    System.out.println("About to fork the threads");
		    rtt = new simpleRTThread((SchedulingParameters)null ,(ReleaseParameters)sp);
		    rtt.setName("t100");
		    rtt.setScheduler(RMScheduler.getDefaultScheduler());
		    rtt.addToFeasibility();
		    rtt.start();
		    rtt1 = new simpleRTThread((SchedulingParameters)null ,(ReleaseParameters)sp1);
		    rtt1.setName("t200");
		    rtt1.setScheduler(RMScheduler.getDefaultScheduler());
		    rtt1.addToFeasibility();
		    rtt1.start();

		    /*
		    rtt2 = new simpleRTThread((SchedulingParameters)null ,(ReleaseParameters)sp2);
		    rtt2.setName("t400");
		    rtt2.setScheduler(RMScheduler.getDefaultScheduler());
		    rtt2.addToFeasibility();
		    rtt2.start();
		    */
		}
		catch (Exception e)
		{
			System.out.println(e);
		}
	}
}
