import javax.realtime.*;
import com.timesys.*;

public class aperiodic
{
    public class aperThread extends RealtimeThread
    {
	public aperThread(SchedulingParameters scheduling,
			  ReleaseParameters release,
			  MemoryParameters memory, MemoryArea area,
			  ProcessingGroupParameters group)
	{
	    super(scheduling, release, memory, area, group, null);
	}

	public void run()
	{
	    long startTime = System.currentTimeMillis();
	    for(int i=0;i <20 ; i++)
		{
		    System.out.println(getName()+" "+(System.currentTimeMillis() - startTime));
		    waitForArrival();
		}
	}
    }

    public static void main(String args[])
    {
	aperiodic a = new aperiodic();
	a.run();
    }

    public void run()
    {
	AbsoluteTime start = new AbsoluteTime(0,0);
	RelativeTime period = new RelativeTime(1000,0);
	RelativeTime cost   = new RelativeTime(100,0);
	RelativeTime deadline = new RelativeTime(1000,0);

	AperiodicParameters ap = new AperiodicParameters(cost, deadline, null, null);
	ProcessingGroupParameters pg = new ProcessingGroupParameters(start, 
								     period, 
								     cost, 
								     deadline, 
								     null,
								     null);

	

	
	aperThread ap1 = new aperThread(null, (ReleaseParameters) ap, null, null, pg);
	aperThread ap2 = new aperThread(null, (ReleaseParameters) ap, null, null, pg);

	ap1.setName("1:");
	ap2.setName("2:");

	ap1.setScheduler(DMScheduler.getDefaultScheduler());
	ap2.setScheduler(DMScheduler.getDefaultScheduler());

	try
	    {
		ap1.addToFeasibility();
		ap2.addToFeasibility();
	    }
	catch (Exception e)
	    {
		e.printStackTrace();
	    }

	ap1.start();
	ap2.start();
	ap1.notifyArrival();
	ap2.notifyArrival();
	ap1.notifyArrival();
	ap2.notifyArrival();
	System.out.println("Done!!");
    }
}
