/*
 * @(#)doubleword.h	1.6 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _ANSI_DOUBLEWORD_H
#define _ANSI_DOUBLEWORD_H

#include <math.h>

/*
 * See src/share/javavm/include/porting/doubleword.h for full documentation.
 */

/*
 * Double Conversions:
 */

#define CVMdouble2Float(val) \
    ((CVMJavaFloat)(val))

#define CVMdouble2Int(val) \
    (double2Int(val))

#define CVMint2Double(val) \
    ((CVMJavaDouble)(val))

/*
 * JAVA_COMPLIANT_d2i, NAN_CHECK_d2i, or neither (but not both) may be
 * defined.
 */

#ifdef JAVA_COMPLIANT_d2i

#define double2Int(val)    (CVMJavaInt)((val))

#elif (defined(NAN_CHECK_d2i))

#define double2Int(val)    ((val) != (val) ? 0 : (CVMJavaInt)(val))

#else

extern CVMJavaInt double2Int(CVMJavaDouble d);

#endif

/*
 * Double Arithmetic:
 */

#define CVMdoubleAdd(op1, op2)	((op1) + (op2))
#define CVMdoubleSub(op1, op2)	((op1) - (op2))
#define CVMdoubleMul(op1, op2)	((op1) * (op2))
/* Divide-by-zero exceptions should be masked */
#define CVMdoubleDiv(op1, op2)	((op1) / (op2))

#ifdef USE_ANSI_FMOD
#define CVMdoubleRem(op1, op2)	(fmod((op1), (op2)))
#endif

/*
 * Double Unary operations
 */

#define CVMdoubleNeg(op)	(-(op))

/*
 * Double Comparisons (returning int value 0, 1, or -1) 
 */

/*
 * Double Compare operation
 */
#define CVMdoubleCompare(op1, op2, opcode_value) \
    (((op1) < (op2)) ? -1 : \
     ((op1) > (op2)) ? 1 : \
     ((op1) == (op2)) ? 0 : \
     ((opcode_value) == -1 || (opcode_value) == 1) ? (opcode_value) :\
     0)

/*
 * Double Constants (CVMJavaDouble's each)
 */
#define CVMdoubleConstZero()    (0.0)
#define CVMdoubleConstOne()     (1.0)

#endif /* _ANSI_DOUBLEWORD_H */
