/*
 * @(#)float.h	1.16 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _GCC_32_BIT_FLOAT_H
#define _GCC_32_BIT_FLOAT_H

/*
 * See src/share/javavm/include/porting/float.h for full documentation.
 */

/*
 * Float Conversions:
 */

#define longMin      (0x8000000000000000LL)
#define longMax      (0x7fffffffffffffffLL)

#define CVMfloat2Long(val) \
    float2Long((val))

/*
 * JAVA_COMPLIANT_f2l, NAN_CHECK_f2l, or neither (but not both) may be
 * defined.
 *
 * If NAN_CHECK_f2l is defined, then BOUNDS_CHECK_f2l may be defined.
 */

#ifdef JAVA_COMPLIANT_f2l

#define float2Long(val)   (CVMJavaLong)((val))

#elif (defined(NAN_CHECK_f2l))

#define float2Long(val)   ((val) != (val) ? 0LL : float2Long0(val))

#else

extern CVMJavaLong float2Long(CVMJavaFloat d);

#endif

#ifdef BOUNDS_CHECK_f2l

#define float2Long0(val) \
    (  ((val) <= -9223372036854775808.0) ? longMin : \
                   ((val) >= 9223372036854775807.0) ? longMax : \
                   (CVMJavaLong)(val) )

#else

#define float2Long0(val)  ((CVMJavaLong)(val))

#endif

#endif /* _GCC_32_BIT_FLOAT_H */
