/*
 * @(#)Default_Reader.java	1.4 00/11/17
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

package com.sun.cdc.i18n.j2me;

import java.io.*;
import com.sun.cdc.i18n.*;

/**
 * Default class reading input streams
 *
 * @author  Nik Shaylor
 * @version 1.0 1/17/2000
 */

public class Default_Reader extends StreamReader {

    public Reader open(InputStream in, String enc) throws UnsupportedEncodingException {
        if(enc == null) {
            return new InputStreamReader(in);
        } else {
            return new InputStreamReader(in, enc);        
        }
    }

    /**
     * Read characters into a portion of an array.
     *
     * @exception  IOException  If an I/O error occurs
     */
    public int read(char cbuf[], int off, int len) throws IOException {
        throw new RuntimeException("Illegal call to J2ME_Reader::read");
    }

    /**
     * Get the size in chars of an array of bytes
     */
    public int sizeOf(byte[] array, int offset, int length) {
        throw new RuntimeException("Illegal call to J2ME_Reader::sizeOf");
    }
    
}
