/*
 * @(#)assert.h	1.4 00/11/09
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _INCLUDED_ASSERT_H
#define _INCLUDED_ASSERT_H

#include "javavm/include/porting/ansi/assert.h"

/*
 * Assert macro
 *
 * CVMassert(expression)   // enabled by CVM_DEBUG_ASSERTS
 *
 * Macro to define statements that are to be expanded only if asserts
 * are enabled:
 *
 * CVMwithAssertsOnly(stmt)
 */

#ifdef CVM_DEBUG_ASSERTS
/* Calling CVMassertHook is to allow us to set a breakpoint
 * when an assertion fails. Otherwise it doesn't seem to be possible
 * to do this in GDB, and once the assertion is thrown, often GDB
 * gets confused about its state.
 */
int CVMassertHook();
#define CVMassert(expression) \
    (void)((expression) || CVMassertHook() || (assert(expression), 0))
#define CVMwithAssertsOnly(x) x
#else
#define CVMassert(expression) ((void)0)
#define CVMwithAssertsOnly(x)
#endif /* CVM_DEBUG */

#endif /* _INCLUDED_ASSERT_H */
