/*
 * @(#)gc_config.h	1.10 00/10/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * This file includes the configuration of the generational collector
 */

#ifndef _INCLUDED_GENERATIONAL_GC_CONFIG_H
#define _INCLUDED_GENERATIONAL_GC_CONFIG_H

#include "javavm/include/gc/gc_impl.h"
#include "javavm/include/gc/generational/generational.h"

/*
 * Barriers in this implementation
 */

#define CVMgcimplWriteBarrierRef(directObj, slotAddr, rhsValue)		  \
    /*									  \
     * Indexing off the virtual base makes this very efficient. Otherwise \
     * we'd have to compute the offset of 'slotAddr' from 'heapBase',	  \
     * before adjusting for card size and indexing cardTable[].		  \
     */									  \
    CVMassert(CARD_TABLE_SLOT_ADDRESS_FOR(slotAddr) >= cardTable);	  \
    CVMassert(CARD_TABLE_SLOT_ADDRESS_FOR(slotAddr) <			  \
	      cardTable + cardTableSize);				  \
    *CARD_TABLE_SLOT_ADDRESS_FOR(slotAddr) = CARD_DIRTY_BYTE;

/* 
 * Global state specific to GC 
 */
struct CVMGCGlobalState {
    CVMUint32  heapSize;
};

#define CVM_GCIMPL_GC_OPTIONS "[-Xgc:youngGen=<youngSemispaceSize>]"

#endif /* _INCLUDED_GENERATIONAL_GC_CONFIG_H */
