/*
 * @(#)semispace.h	1.4 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * This file is specific and only visible to semi-space copying GC
 * implementation.  
 */

#ifndef _INCLUDED_SEMISPACE_H
#define _INCLUDED_SEMISPACE_H

typedef struct CVMSsHeap CVMSsHeap;
typedef struct CVMSsSemispace CVMSsSemispace;

/*
 * The structure of the heap in a semi-space copying collector
 */
struct CVMSsHeap {
    CVMUint32       size;     /* Size of heap in no. of bytes */
    CVMSsSemispace* from;     /* The from-space */
    CVMSsSemispace* to;       /* The to-space */
    CVMUint32       sizeOfBitmaps; /* The size in bytes of the following map */
    CVMUint32*      forwarded;/* A bitmap indicating forwarded objects */
};

/*
 * The structure of a semi-space.
 */
struct CVMSsSemispace {
    CVMUint32* allocPtr;  /* The current allocation pointer */
    CVMUint32* topData;   /* The top of the heap */
    CVMUint32* threshold; /* The allocation threshold for GC */
    CVMUint32  data[1];   /* The data for this semi-space */
};

#endif /* _INCLUDED_SEMISPACE_H */

