/*
 * @(#)globalroots.h	1.13 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _INCLUDED_GLOBALROOTS_H
#define _INCLUDED_GLOBALROOTS_H

#include "javavm/include/defs.h"
#include "javavm/include/objects.h"
#include "javavm/include/interpreter.h" /* needed before stacks.h */
#include "javavm/include/stacks.h"

typedef CVMFreelistFrame CVMGlobalRootsFrame;

extern CVMObjectICell*
CVMID_getGlobalRoot(CVMExecEnv* ee);

extern CVMObjectICell*
CVMID_getClassGlobalRoot(CVMExecEnv* ee);

extern CVMObjectICell*
CVMID_getClassLoaderGlobalRoot(CVMExecEnv* ee);

extern CVMObjectICell*
CVMID_getWeakGlobalRoot(CVMExecEnv* ee);

extern void
CVMID_freeGlobalRoot(CVMExecEnv* ee, CVMObjectICell* glRoot);

extern void
CVMID_freeClassGlobalRoot(CVMExecEnv* ee, CVMObjectICell* glRoot);

extern void
CVMID_freeClassLoaderGlobalRoot(CVMExecEnv* ee, CVMObjectICell* glRoot);

extern void
CVMID_freeWeakGlobalRoot(CVMExecEnv* ee, CVMObjectICell* glRoot);

/*
 * Scan global roots for GC, calling 'callback' on each
 */
extern CVMFrameGCScannerFunc CVMglobalrootFrameScanner;

#endif /* _INCLUDED_GLOBALROOTS_H */

