/*
 * @(#)localroots.h	1.16 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _INCLUDED_LOCALROOTS_H
#define _INCLUDED_LOCALROOTS_H

#include "javavm/include/defs.h"
#include "javavm/include/objects.h"
#include "javavm/include/stacks.h"
#include "javavm/include/interpreter.h"
#include "javavm/include/gc_common.h"

/*
 * An CVMLocalRootsFrame is pushed each time CVMID_localrootBegin is called
 * and popped by CVMID_localrootEnd.
 *
 * There is no out-of-order deletion in this type of frame; therefore it is not
 * an CVMFreelistFrame
 */
struct CVMLocalRootsFrame {
    CVMFrame        cvmFrame;
    CVMStackVal32   vals[1];    /* space for local roots */
};

#define CVMID_localrootBegin(ee_)					\
{									\
    CVMExecEnv*         currentLRee_ = ee_;		       		\
    CVMStack*           lrStack_ = &((ee_)->localRootsStack);		\
    CVMFrame*           currentLRFrame_ = lrStack_->currentFrame;	\
    CVMassert(CVMD_isgcSafe(ee_));					\
    CVMpushGCRootFrame(ee_, lrStack_, currentLRFrame_,			\
		       CVMbaseFrameCapacity, CVMlocalrootFrameScanner);

#define CVMID_localrootEnd()						\
    CVMpopGCRootFrame(lrStack_, currentLRFrame_);			\
}

/*
 * The following function is private to the local roots implementation
 */
extern CVMObjectICell*
CVMIDprivate_allocateLocalRoot(CVMExecEnv* ee,
			       CVMStack* lrStack, CVMFrame* lrFrame);

#define CVMID_localrootDeclare(T, v)					   \
    T * v = (T *)CVMIDprivate_allocateLocalRoot(currentLRee_,		   \
						lrStack_, currentLRFrame_)

/*
 * Scan local roots for GC, calling 'callback' on each
 */
extern CVMFrameGCScannerFunc CVMlocalrootFrameScanner;

#endif /* _INCLUDED_LOCALROOTS_H */

