/*
 * @(#)endianness.h	1.7 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _INCLUDED_PORTING_ENDIANNESS_H
#define _INCLUDED_PORTING_ENDIANNESS_H

#include "javavm/include/porting/defs.h"
/*
 * The platform defines the CVM_ENDIANNESS and CVM_DOUBLE_ENDIANNESS
 * macros to be either CVM_LITTLE_ENDIAN or CVM_BIG_ENDIAN.
 */

#define CVM_LITTLE_ENDIAN	1234
#define CVM_BIG_ENDIAN		4321

#include CVM_HDR_ENDIANNESS_H

/*
 * Sanity check the setting. 
 */
#if (CVM_ENDIANNESS == CVM_LITTLE_ENDIAN)
#elif (CVM_ENDIANNESS == CVM_BIG_ENDIAN)
#else
#error CVM_ENDIANNESS must be defined as CVM_LITTLE_ENDIAN or CVM_BIG_ENDIAN
#endif

#if (CVM_DOUBLE_ENDIANNESS == CVM_LITTLE_ENDIAN)
#elif (CVM_DOUBLE_ENDIANNESS == CVM_BIG_ENDIAN)
#else
#error CVM_DOUBLE_ENDIANNESS must be defined as CVM_LITTLE_ENDIAN or CVM_BIG_ENDIAN
#endif

#endif /* _INCLUDED_PORTING_ENDIANNESS_H */
