/*
 * @(#)path.h	1.7 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _INCLUDED_PORTING_PATH_H
#define _INCLUDED_PORTING_PATH_H

#include "javavm/include/porting/defs.h"

/*
 * Macros:
 *
 *   CVM_PATH_MAXLEN
 *
 *   Maximum path length.  Usually the same as PATH_MAX.
 *
 *   CVM_PATH_CLASSFILEEXT
 *
 *   The class file extension.  Usually "class".
 *
 *   CVM_PATH_LOCAL_DIR_SEPARATOR
 *
 *   The directory separator.  Commonly '/'.
 *
 *   CVM_PATH_CLASSPATH_SEPARATOR
 *
 *   The class path separator.  Commonly ":".
 *
 *   CVM_PATH_CURDIR
 *
 *   The current directory.  Usually ".".
 *
 * Functions:
 */

/*
 * Canonicalize pathname stored as "len" characters in "path", placing
 * result in "out".
 */
extern int CVMcanonicalize(const char* path, char* out, int len);

#include CVM_HDR_PATH_H

#endif /* _INCLUDED_PORTING_PATH_H */
