/*
 * @(#)system.h	1.4 00/05/22
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * System porting layer interfaces.
 */

#ifndef _INCLUDED_PORTING_SYSTEM_H
#define _INCLUDED_PORTING_SYSTEM_H

#include "javavm/include/porting/defs.h"

/*
 * Halt the VM immediately with the given status, as defined by Runtime.halt().
 * The function should never return.
 */

void CVMhalt(CVMInt32 status);

/*
 * Something bad has happened, even in a non-debug VM.
 * Print the message on an appropriate console and halt 
 * the computation in a system-dependent manner. It may
 * cause either a core dump or a suspended thread.
 * If CVM_DEBUG, then call CVMassertHook first for
 * ease of debugging.
 */
void CVMsystemPanic( const char * msg );

#ifdef CVM_DEBUG
#define CVMpanic(msg) ( CVMassertHook(), CVMsystemPanic(msg) )
#else
#define CVMpanic(msg)  ( CVMsystemPanic(msg) )
#endif

#include CVM_HDR_SYSTEM_H

#endif /* _INCLUDED_PORTING_SYSTEM_H */
