/*
 * @(#)vm-defs.h	1.6 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _INCLUDED_PORTING_VM_DEFS_H
#define _INCLUDED_PORTING_VM_DEFS_H

/*
 * These types are exported to the porting layer.
 */

#include "javavm/include/porting/defs.h"

/*
 * Convenience macros
 */
#define CVM_STRUCT_TYPEDEF(structName) \
    typedef struct structName structName
#define CVM_UNION_TYPEDEF(structName) \
    typedef union structName structName
#define CVM_ENUM_TYPEDEF(structName) \
    typedef enum structName structName

/*
 * C types corresponding to Java types
 */
typedef CVMInt8         CVMJavaByte;
typedef CVMInt16        CVMJavaShort;
typedef CVMUint16       CVMJavaChar;
typedef CVMUint8        CVMJavaBoolean;
typedef CVMInt32        CVMJavaInt;
typedef CVMfloat32      CVMJavaFloat;
typedef CVMInt64        CVMJavaLong;
typedef CVMfloat64      CVMJavaDouble;

typedef CVMUint32	CVMBool;

#define CVM_TRUE	(1 == 1)
#define CVM_FALSE	(!CVM_TRUE)

/* forward declarations, defined by porting layer */

/* sync.h */
CVM_STRUCT_TYPEDEF(CVMMutex);
CVM_STRUCT_TYPEDEF(CVMCondVar);

/* threads.h */
CVM_STRUCT_TYPEDEF(CVMThreadID);

/* globals.h */
CVM_STRUCT_TYPEDEF(CVMTargetGlobalState);

#endif /* _INCLUDED_PORTING_VM_DEFS_H */
