/*
 * @(#)EllisGC_ST.java	1.2 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
/*
 * The single threaded version of EllisGC
 */
class Node {
    Node left, right;
}

public class EllisGC_ST {

	public static final int kNumIterations      = 50;

	/* 15 levels = 1.5M
	 */
	public static final int kStretchTreeDepthX    = 19;	// about 24Mb
	public static final int kLongLivedTreeDepthX  = 18;  // about 12Mb
	public static final int kShortLivedTreeDepthX = 13;	// about 0.4Mb

	public static final int kStretchTreeDepth    = 19;	// about 24Mb
	public static final int kLongLivedTreeDepth  = 18;  // about 12Mb
	public static final int kShortLivedTreeDepth = 13;	// about 0.4Mb


	static void Populate(int iDepth, Node thisNode) {
		if (iDepth<=0)
			return;
		else {
			iDepth--;
			thisNode.left  = new Node();
			thisNode.right = new Node();
			Populate (iDepth, thisNode.left);
			Populate (iDepth, thisNode.right);
		}
	}


	public static void main(String args[]) {
		Node	root;
		Node	longLivedTree;
		Node	tempTree;

		System.out.println("Garbage Collector Test");
		System.out.println(" Stretching memory with a binary tree of depth "
+ kStretchTreeDepth);
		System.out.println(" Creating a long-lived binary tree of depth " +
kLongLivedTreeDepth);
		System.out.println(" Creating " + kNumIterations + " binary trees of depth " + kShortLivedTreeDepth);

		// Stretch the memory space quickly
		tempTree = new Node();
		Populate(kStretchTreeDepth, tempTree);
		tempTree = null;

		// Create a long lived object
		longLivedTree = new Node();
		Populate(kLongLivedTreeDepth, longLivedTree);

		for (int c=0; c<kNumIterations; c++) {
		    root = new Node();
		    Populate(kShortLivedTreeDepth, root);
		}

		root = longLivedTree;	// fake reference to LongLivedTree to keep it from being optimized away
	}
}
