/*
 * @(#)DMArrayCopyCharTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayCopyCharTest extends Thread {

   private char [] privateArray;
   public static Object lock;

   public DMArrayCopyCharTest(int num) {
      privateArray = new char[num];
   }

   private native void nSetArray(char [] srcArray, char [] dstArray);

   public void setArray(char [] srcArray) {
	this.nSetArray(srcArray, this.privateArray);
   }

   public char getArrayElement(int index) {
      return(privateArray[index]);
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      System.out.println();

      char [] charArray = new char[arrayLength];
      for(int i=0; i<arrayLength; i++)
         charArray[i] = Character.forDigit(rd.nextInt(Character.MAX_RADIX), Character.MAX_RADIX);

      setArray(charArray);

      for(int i=0; i<arrayLength; i++) {
         if(getArrayElement(i) != charArray[i]) {
            pass = false;	
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayCopyCharTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayCopyCharTest, Data written and read were not same");
   }

   public static void main(String args[]) {
      Object lck = new Object();
      Random rd = new Random();

      DMArrayCopyCharTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayCopyCharTest test = new DMArrayCopyCharTest(rd.nextInt(100));

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
