/*
 * @(#)DMArrayRWBodyDoubleTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayRWBodyDoubleTest extends Thread {

   private double [] privateArray;
   public static Object lock;

   public DMArrayRWBodyDoubleTest(int num) {
      privateArray = new double[num];
   }

   private native void nSetArray(double[] dstArray, double[] srcArray, int arrayLength);

   public void setArray(double [] srcArray) {
        this.nSetArray(this.privateArray, srcArray, getArrayLength());
   }

   public double [] getArray() {
      int arrLength = getArrayLength();
      double [] doubleArray = new double[arrLength];

      for(int i=0; i<arrLength; i++)
         doubleArray[i] = privateArray[i];

       return doubleArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      double [] inArray = new double[arrayLength];
      for(int i=0; i<arrayLength; i++)
         inArray[i] = rd.nextDouble();

      setArray(inArray);
      double [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(inArray[i] != outArray[i]) {
            pass = false;
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayRWBodyDoubleTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayRWBodyDoubleTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayRWBodyDoubleTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayRWBodyDoubleTest test = new DMArrayRWBodyDoubleTest(rd.nextInt(100));

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
