/*
 * @(#)DMArrayRWBodyRefTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayRWBodyRefTest extends Thread {

   private String [] privateArray;
   public static Object lock;

   public DMArrayRWBodyRefTest(int num) {
      privateArray = new String[num];
   }

   private native void nSetArray(String[] dstArray, String[] srcArray, int arrayLength);

   public void setArray(String [] srcArray) {
        this.nSetArray(this.privateArray, srcArray, getArrayLength());
   }

   public String [] getArray() {
      int arrLength = getArrayLength();
      String [] stringArray = new String[arrLength];

      for(int i=0; i<arrLength; i++)
         stringArray[i] = privateArray[i];

       return stringArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      String [] inArray = new String[arrayLength];
      for(int i=0; i<arrayLength; i++)
         inArray[i] = String.valueOf(rd.nextInt());

      setArray(inArray);
      String [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(inArray[i] != outArray[i]) {
            pass = false;
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayRWBodyRefTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayRWBodyRefTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayRWBodyRefTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayRWBodyRefTest test = new DMArrayRWBodyRefTest(rd.nextInt(100));

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
