/*
 * @(#)DMArrayRWRefTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayRWRefTest extends Thread {

   private String [] privateArray;
   public static Object lock;

   public DMArrayRWRefTest(int num) {
      privateArray = new String[num];
   }

   private native void nSetArray(String [] dstArray, String [] srcArray, int arrayLength);

   public void setArray(String [] strArray) {
	this.nSetArray(this.privateArray, strArray, getArrayLength());
   }

   public String [] getArray() {
      int arrLength = getArrayLength();
      String [] strArray = new String[arrLength];
 
      for(int i=0; i<arrLength; i++)
         strArray[i] = privateArray[i];

       return strArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      String [] inArray = new String[arrayLength];
      for(int i=0; i<arrayLength; i++)
         inArray[i] = String.valueOf(rd.nextInt());

      setArray(inArray);
      String [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(outArray[i] != inArray[i]) {
            pass = false;	
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayRWRefTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayRWRefTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayRWRefTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayRWRefTest test = new DMArrayRWRefTest(rd.nextInt(100));

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
