/*
 * @(#)IDArrayRWDoubleTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class IDArrayRWDoubleTest extends Thread {

   private double [] privateArray;

   public IDArrayRWDoubleTest(int num) {
      privateArray = new double[num];
   }

   private native void nSetArray(double [] dstArray, double [] srcArray, int arrayLength);

   public void setArray(double [] doubleArray) {
	this.nSetArray(this.privateArray, doubleArray, getArrayLength());
   }

   public double [] getArray() {
      int arrLength = getArrayLength();
      double [] doubleArray = new double[arrLength];

      for(int i=0; i<arrLength; i++)
         doubleArray[i] = privateArray[i];

       return doubleArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      double [] inArray = new double[arrayLength];
      for(int i=0; i<arrayLength; i++)
         inArray[i] = rd.nextDouble();

      setArray(inArray);
      double [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(outArray[i] != inArray[i]) {
            pass = false;       
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: IDArrayRWDoubleTest, Data written and read were same");
      else
         System.out.println("FAIL: IDArrayRWDoubleTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      int numGcThreads = 10;
      Random rd = new Random();

      IDArrayRWDoubleTest test = new IDArrayRWDoubleTest(rd.nextInt(100));

      GcThread.sleepCount = numGcThreads;
      GcThread [] gc = new GcThread[numGcThreads];
      for(int i=0; i<gc.length; i++) {
         gc[i] = new GcThread();
         gc[i].start();
      }

      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      for(int i=0; i<gc.length; i++) {
         gc[i].interrupt();
      }

      try {
         for(int i=0; i<gc.length; i++) {
            gc[i].join();
         }
      } catch (Exception e) {}
   }

}
