/*
 * @(#)IDArrayRWFloatTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class IDArrayRWFloatTest extends Thread {

   private float [] privateArray;

   public IDArrayRWFloatTest(int num) {
      privateArray = new float[num];
   }

   private native void nSetArray(float [] dstArray, float [] srcArray, int arrayLength);

   public void setArray(float [] floatArray) {
	this.nSetArray(this.privateArray, floatArray, getArrayLength());
   }

   public float [] getArray() {
      int arrLength = getArrayLength();
      float [] floatArray = new float[arrLength];

      for(int i=0; i<arrLength; i++)
         floatArray[i] = privateArray[i];

       return floatArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      float [] inArray = new float[arrayLength];
      for(int i=0; i<arrayLength; i++)
         inArray[i] = rd.nextFloat();

      setArray(inArray);
      float [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(outArray[i] != inArray[i]) {
            pass = false;       
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: IDArrayRWFloatTest, Data written and read were same");
      else
         System.out.println("FAIL: IDArrayRWFloatTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      int numGcThreads = 10;
      Random rd = new Random();

      IDArrayRWFloatTest test = new IDArrayRWFloatTest(rd.nextInt(100));

      GcThread.sleepCount = numGcThreads;
      GcThread [] gc = new GcThread[numGcThreads];
      for(int i=0; i<gc.length; i++) {
         gc[i] = new GcThread();
         gc[i].start();
      }

      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      for(int i=0; i<gc.length; i++) {
         gc[i].interrupt();
      }

      try {
         for(int i=0; i<gc.length; i++) {
            gc[i].join();
         }
      } catch (Exception e) {}
   }

}
