#
# @(#)results.sh	1.1 00/10/24
#
# Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
#
# This software is the proprietary information of Sun Microsystems, Inc.
# Use is subject to license terms.
#
#!/bin/sh

echo ""
echo "Collecting Results in GenerationGC Test"
echo "---------------------------------------"
echo ""

if [ -f build.log ]
then
	if grep error build.log
	then
		echo "GenerationGC Test build FAILED"
		echo "For more detail look in build.log"
	else
		echo "GenerationGC Test build PASSED"
	fi
else
	echo "There is no build.log to collect build results"
fi

echo ""
echo ""

if [ $# -ne 0 ]
then
	if [ "$1" = "vxworks" ]
	then
		TARGET=vxworks
	elif [ "$1" = "linux" ]
	then
		TARGET=linux
	elif [ "$1" = "solaris" ]
	then
		TARGET=solaris
	else
		echo "Unknown target exiting"
		exit
	fi
else
	echo "Please specify which target you want to collect the results for."
	exit
fi

if [ -f run.$TARGET.log ]
then
	FAIL=`grep -c FAIL run.$TARGET.log`
	PASS=`grep -c PASS run.$TARGET.log`
	UNRESOLVED=`grep -c UNRESOLVED run.$TARGET.log`

	if [ $FAIL -eq 0 ] && [ $UNRESOLVED -eq 0 ]
	then
		echo "GenerationGC Test run PASSED"
	fi

	if [ $FAIL -ne 0 ]
	then
		echo "GenerationGC Test run FAILED"
		echo ""
	fi

	if [ $UNRESOLVED -ne 0 ]
	then
		echo "GenerationGC Test run has UNRESOLVED test cases"
		echo ""
	fi

	echo ""
	echo "Number of PASSES     = $PASS"
	echo "Number of FAILS      = $FAIL"
	echo "Number of UNRESOLVED = $UNRESOLVED"
	echo ""

	if [ $FAIL -ne 0 ]
	then
		echo ""
		echo "The following are the tests which failed"
		echo "For more details please look in run.$TARGET.log"
		echo ""
		grep FAIL run.$TARGET.log
		echo ""
	fi

	if [ $UNRESOLVED -ne 0 ]
	then
		echo ""
		echo "The following are the unresolved tests"
		echo "For more detail look in run.$TARGET.log"
		echo ""
		grep UNRESOLVED run.$TARGET.log
		echo ""
	fi
else
	echo "There is no run.$TARGET.log to collect run results"
fi

echo ""
