/*
 * @(#)InterruptTest.java	1.4 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

public class InterruptTest {

    public static void main(String args[]) {
	test0(Integer.parseInt(args[0]));
    }

    static boolean abort = false;

    static void test0(int iterations) {
        final Object lock = new Object();
        Thread thr = new Thread() {

            public void run() {
		yield();
                while (!abort) {
                    synchronized (lock) {
			try {
			    lock.wait();
			} catch (InterruptedException ie) {
			    System.err.println("Interrupted! (" +
				isInterrupted() + ") (" +
				interrupted() + ")");
			}
                    }
                }
            }
        };

        thr.start();

        for (int i = 0; i < iterations; ++i) {
            synchronized (lock) {
                thr.interrupt();
		try {
		    Thread.sleep(100);
		} catch (InterruptedException ie) {
		}
            }
        }
	abort = true;
	thr.interrupt();
    }

}
