/*
 * @(#)StringSignatureTest.java	1.6 00/11/17
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
/** Exercises the regression test for the bug that used to be in the 
    TypeID system:

    1. Reflection code makes full signature iterator for method's
    TypeID.

    2. Full signature iterator runs until it returns
    CVM_TYPEID_ENDFUNC.

    3. Terse signature contains CVM_TYPEID_OBJ for String argument to
    method. Detail for that argument, though, contains a field TypeID
    of 12, which is confused with CVM_TYPEID_ENDFUNC even though
    conceptually these two tokens are in different namespaces.

    This caused an assertion failure in CVMreflectGetParameterTypes on
    debug builds.
*/

import java.lang.reflect.*;

public class StringSignatureTest {
    public void methodTakingString(String x) {
	System.out.println("methodTakingString(" + x + ")");
    }

    public static void main(String[] args) {
	try {
	    StringSignatureTest test = new StringSignatureTest();
	    // Next line causes assertion failure
	    Method method =
		test.getClass().getMethod("methodTakingString",
					  new Class[] { String.class });
	    method.invoke(test, new Object[] { "Hello, world" });
	    System.err.println("Test passed.");
	}
	catch (Exception e) {
	    e.printStackTrace();
	    System.err.println("TEST FAILED");
	}
    }
}
