/*
 * @(#)CVMTypeCode.java	1.3 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
/*
 * CVM has a complex scheme for representing types as 16-bit
 * cookies. This code mimics the run-time code and thus builds the
 * corresponding data structures, to be ROMed.
 */

package vm;

public interface CVMTypeCode {
    public static final int CVM_T_ERROR   =          0;
    public static final int CVM_T_VOID    =          1;
    public static final int CVM_T_INT     =          2;
    public static final int CVM_T_SHORT   =          3;
    public static final int CVM_T_CHAR    =          4;
    public static final int CVM_T_LONG    =          5;
    public static final int CVM_T_BYTE    =          6;
    public static final int CVM_T_FLOAT   =          7;
    public static final int CVM_T_DOUBLE  =          8;
    public static final int CVM_T_BOOLEAN =          9;

    public static final int CVM_T_OBJ     =          10;
    public static final int CVM_T_ARRAY   =          11;
    public static final int CVM_T_ENDFUNC =          12;

    public static final int  CVMtypeArrayMask    =   0xe000;
    public static final int  CVMtypeBasetypeMask =   0x1fff;
    public static final int  CVMtypeArrayShift   =   13;
    public static final int  CVMtypeBigArray     =   0xe000;
    public static final int  CVMtypeLastScalar   =   CVM_T_BOOLEAN;
    public static final int  CVMtypeMaxSmallArray=   6;
 

}
