/*
 * @(#)jni_cvm_util.h	1.5 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#include "javavm/include/jdk2cvm.h"
#include "javavm/include/common_exceptions.h"
#include "javavm/include/interpreter.h"

#define JNUThrowFunc(exception, env, msg) \
    CVMthrow##exception(CVMjniEnv2ExecEnv(env), msg);

/* Throw common exceptions */
#define JNU_ThrowNullPointerException(env, msg) \
    JNUThrowFunc(NullPointerException, env, msg)

#define JNU_ThrowArrayIndexOutOfBoundsException(env, msg) \
    JNUThrowFunc(ArrayIndexOutOfBoundsException, env, msg)

#define JNU_ThrowOutOfMemoryError(env, msg) \
    JNUThrowFunc(OutOfMemoryError, env, msg)

#define JNU_ThrowIllegalArgumentException(env, msg) \
    JNUThrowFunc(IllegalArgumentException, env, msg)

#define JNU_ThrowIllegalAccessError(env, msg) \
    JNUThrowFunc(IllegalAccessError, env, msg)

#define JNU_ThrowIllegalAccessException(env, msg) \
    JNUThrowFunc(IllegalAccessException, env, msg)

#define JNU_ThrowInternalError(env, msg) \
    JNUThrowFunc(InternalError, env, msg)

#define JNU_ThrowNoSuchFieldException(env, msg) \
    JNUThrowFunc(NoSuchFieldException, env, msg)

#define JNU_ThrowNoSuchMethodException(env, msg) \
    JNUThrowFunc(NoSuchMethodException, env, msg)

#define JNU_ThrowClassNotFoundException(env, msg) \
    JNUThrowFunc(ClassNotFoundException, env, msg)

#define JNU_ThrowNumberFormatException(env, msg) \
    JNUThrowFunc(NumberFormatException, env, msg)

#define JNU_ThrowIOException(env, msg) \
    JNUThrowFunc(IOException, env, msg)

#define JNU_ThrowNoSuchFieldError(env, msg) \
    JNUThrowFunc(NoSuchFieldError, env, msg)

#define JNU_ThrowNoSuchMethodError(env, msg) \
    JNUThrowFunc(NoSuchMethodError, env, msg)

#define JNU_ThrowStringIndexOutOfBoundsException(env, msg) \
    JNUThrowFunc(StringIndexOutOfBoundsException, env, msg)

#define JNU_ThrowInstantiationException(env, msg) \
    JNUThrowFunc(InstantiationException, env, msg)

/* Class constants */ 
#define JNU_ClassString(env) \
    (CVMcbJavaInstance(CVMsystemClass(java_lang_String)))

#define JNU_ClassClass(env) \
    (CVMcbJavaInstance(CVMsystemClass(java_lang_Class)))

#define JNU_ClassObject(env) \
    (CVMcbJavaInstance(CVMsystemClass(java_lang_Object)))

#define JNU_ClassThrowable(env) \
    (CVMcbJavaInstance(CVMsystemClass(java_lang_Throwable)))

/* These functions are in verifyformat.c, which used to be 
 * called check_format.c.
 */
extern jboolean VerifyClassname(char *name, jboolean allowArrayClass);
extern jboolean VerifyFixClassname(char *utf_name);
extern jboolean TranslateFromVMClassName(char *utf_name);
