/*
 * %W% %E%
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

package javax.microedition.io;

import java.io.*;

/**
 * This interface defines the capabilities that an input stream connection
 * must have.
 *
 * @author  Nik Shaylor
 * @version 1.1 1/7/2000
 */
public interface InputConnection extends Connection {
    /**
     * Open and return an input stream for a connection.
     *
     * @return                 An input stream
     * @exception IOException  If an I/O error occurs
     */
    public InputStream openInputStream() throws IOException;

    /**
     * Open and return a data input stream for a connection.
     *
     * @return                 An input stream
     * @exception IOException  If an I/O error occurs
     */
    public DataInputStream openDataInputStream() throws IOException;
}
