/*
 * @(#)Default_Writer.java	1.4 00/11/17
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

package com.sun.cdc.i18n.j2me;

import java.io.*;
import com.sun.cdc.i18n.*;

/**
 * Default class for writing output streams.
 *
 * @author  Nik Shaylor
 * @version 1.0 1/17/2000
 */
public class Default_Writer extends StreamWriter {

    public Writer open(OutputStream in, String enc)  throws UnsupportedEncodingException {
        if(enc == null) {
            return new OutputStreamWriter(in);
        } else {
            return new OutputStreamWriter(in, enc);        
        }
    }

    /**
     * Write a portion of an array of characters.
     *
     * @param  cbuf  Buffer of characters to be written
     * @param  off   Offset from which to start reading characters
     * @param  len   Number of characters to be written
     *
     * @exception  IOException  If an I/O error occurs
     */
    public void write(char cbuf[], int off, int len) throws IOException {
        throw new RuntimeException("Illegal call to J2ME_Writer::write");
    }


    /**
     * Get the size in bytes of an array of chars
     */
    public int sizeOf(char[] array, int offset, int length) {
        throw new RuntimeException("Illegal call to J2ME_Writer::sizeOf");
    }

}
