/*
 * @(#)gen_markcompact.h	1.6 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * This file includes the implementation of a copying semispace generation.
 */

#include "javavm/include/defs.h"
#include "javavm/include/objects.h"
#include "javavm/include/classes.h"
#include "javavm/include/directmem.h"

/*
 * This file is generated from the GC choice given at build time.
 */
#include "generated/javavm/include/gc_config.h"

#include "javavm/include/gc_common.h"
#include "javavm/include/gc/gc_impl.h"

#include "javavm/include/gc/generational/generational.h"

typedef struct CVMMCPreservedItem {
    CVMUint32* movedRef;
    CVMUint32  originalWord;
} CVMMCPreservedItem;

struct CVMGenMarkCompactGeneration {
    CVMGeneration gen;

    /* To-do list (will be "borrowed" from young gen) */
    CVMObject**   todoList;
    CVMUint32     todoIdx;
    CVMUint32     todoSize;
    
    /* Preserved header words */
    CVMMCPreservedItem*   preservedItems;
    CVMUint32             preservedIdx;
    CVMUint32             preservedSize;
    
    /* Heap space */
    CVMGenSpace*  theSpace;      /* The space allocated for this gen. */
};

typedef struct CVMGenMarkCompactGeneration CVMGenMarkCompactGeneration;

/*
 * Allocate a new one of these generations
 */
extern CVMGeneration* 
CVMgenMarkCompactAlloc(CVMUint32* space, CVMUint32 totalNumBytes);

/*
 * Free one of these generations
 */
void
CVMgenMarkCompactFree(CVMGenMarkCompactGeneration* thisGen);
