/*
 * @(#)limits.h	1.2 00/07/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * This file states values for our implementation limits.
 */

#ifndef _INCLUDED_LIMITS_H
#define _INCLUDED_LIMITS_H

#include "javavm/include/defs.h"
#include "javavm/include/typeid.h"
#include "javavm/include/constantpool.h"

/*
 * An object can't be larger than 16K-1 words long, including the header.
 * Bigger objects cannot encode their instance sizes in the 16-bit
 * class instance size field.
 */
#define CVM_LIMIT_OBJECT_NUMFIELDWORDS \
    ((16 * 1024) - (sizeof(CVMObjectHeader) / sizeof(CVMObject*)) - 1)

/*
 * A method table cannot include more than 65535 entries
 */
#define CVM_LIMIT_NUM_METHODTABLE_ENTRIES 65535

#endif /* _INCLUDED_LIMITS_H */
