/*
 * @(#)xrun.h	1.3 00/09/08
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _INCLUDED_XRUN_H
#define _INCLUDED_XRUN_H

#include "javavm/include/defs.h"
#include "javavm/include/objects.h"
#include "javavm/include/classes.h"
#include "javavm/include/interpreter.h"
#include "javavm/include/stacks.h"
#include "javavm/include/porting/globals.h"
#include "javavm/include/sync.h"
#include "javavm/include/cstates.h"
#include "javavm/include/jni_impl.h"
#include "javavm/include/packages.h"

typedef jint (JNICALL *JVM_OnUnload_t)(JavaVM *, char *, void *);

/*
 * Each item stored in a table contains Xrun loaded share native
 * library object ref and the function pointer of calling JVM_onUnload
 */
typedef struct CVMXrunItem {
    jobject shareLibRef;
    JVM_OnUnload_t onUnloadFunc;
} CVMXrunItem;

/*
 * A table of items containing a set of Xrun loaded share native
 * library object ref and the function pointer of JVM_onUnload
 */
typedef struct CVMXrunTable {
    CVMInt32 elemCnt;
    CVMXrunItem *table;
} CVMXrunTable;

#define CVMXrunGetCnt(tab)             	((tab)->elemCnt)
#define CVMXrunGetItemTable(tab)        ((tab)->table)
#define CVMXrunSetCnt(tab, num)        	((tab)->elemCnt = num)
#define CVMXrunSetItemTable(tab, itab)  ((tab)->table = itab)
#define CVMXrunSetNextItem(tab, objRef, fptr) {     \
    tab->table[tab->elemCnt].shareLibRef = objRef;  \
    tab->table[tab->elemCnt].onUnloadFunc = fptr;   \
}
#define CVMXrunBumpCnt(tab)		((tab)->elemCnt++)
#define CVMXrunIsEmptyTable(tab)	((tab)->elemCnt == 0)

extern CVMBool CVMXrunInitTable(CVMXrunTable *onUnloadTable, 
			    CVMInt32 numXrunArguments);
extern void CVMXrunAppendToTable(CVMXrunTable *onUnloadTable, jobject libRef,
				 JVM_OnUnload_t fptr);
extern void CVMXrunProcessTable(CVMXrunTable *onUnloadTable, JavaVM *vm, 
			        JNIEnv *env);

#endif /* _INCLUDED_XRUN_H */
