/*
 * @(#)PathComponent.java	1.2 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
package util;

import dependenceAnalyzer.*;
import java.util.Enumeration;

public class PathComponent {
    PathComponent       root;
    public DependenceNode link;

    public static int INSET = (1<<25);

    public PathComponent( PathComponent r, DependenceNode l ){
        root = r;
        link = l;
    }

    public void print( java.io.PrintStream o ){
        if ( root != null ){
            root.print( o );
            o.print(" => ");
        }
        o.print( link.name() );
    }

    public void grow( Set tipset ){
        Enumeration t = link.dependsOn();
        while ( t.hasMoreElements() ){
            DependenceArc arc = (DependenceArc)(t.nextElement());
            DependenceNode to = (DependenceNode) arc.to();
            if ( (to.flags&INSET) != 0 )
                continue;
            tipset.addElement( new PathComponent( this, to ) );
        }
    }    
}

