/*
 * @(#)localroots.c	1.11 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#include "javavm/include/defs.h"
#include "javavm/include/objects.h"
#include "javavm/include/indirectmem.h"
#include "javavm/include/stacks.h"
#include "javavm/include/localroots.h"
#include "javavm/include/stackwalk.h"
#include "javavm/include/gc_common.h"

/*
 * The following function is private to the local roots implementation.
 * It allocates a new slot from a local roots frame.
 */
CVMObjectICell*
CVMIDprivate_allocateLocalRoot(CVMExecEnv* ee, 
			       CVMStack* lrStack, CVMFrame* lrFrame)
{
    CVMStackVal32* result = 0;
    CVMframeAllocFromTop(ee, lrStack, lrFrame, result);
    CVMassert(result != 0);
    return &result->ref;
}

void
CVMlocalrootFrameScanner(CVMExecEnv* ee,
			 CVMFrame* lrFrame, CVMStackChunk* lrChunk,
			 CVMRefCallbackFunc callback, void* data,
			 CVMGCOptions* opts)
{
    CVMwalkRefsInGCRootFrame(lrFrame, (CVMStackVal32*)(lrFrame + 1),
			     lrChunk, callback, data, CVM_FALSE);
}    
