/*
 * @(#)stackwalk.c	1.9 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#include "javavm/include/defs.h"
#include "javavm/include/objects.h"
#include "javavm/include/classes.h"
#include "javavm/include/interpreter.h"
#include "javavm/include/stacks.h"
#include "javavm/include/stackwalk.h"
#include "javavm/include/clib.h"

/*
 * Initialize stack walk to point to top of frame
 */
void
CVMstackwalkInit(CVMStack* s, CVMStackWalkContext* c)
{
    c->frame   = s->currentFrame;
    c->chunk   = s->currentStackChunk;
}

/*
 * Destroy stack walk
 */
void
CVMstackwalkDestroy(CVMStackWalkContext* c)
{
}

/*
 * Get previous frame, and make c->chunk follow to point to the last
 * chunk of the frame
 */
void
CVMstackwalkPrev(CVMStackWalkContext* c)
{
    CVMFrame* curFrame = c->frame;
    CVMframeGetPreviousUpdateChunk(c->chunk, curFrame, {c->chunk = chunk_;});
    c->frame = curFrame;
}
