/*
 * @(#)DynLinkTest.c	1.3 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
#include "javavm/test/DynLinkTest.h"
#include "javavm/include/porting/linker.h"

/* Native code for DynLinkTest. Note that this makes CVM-internal
   calls to the porting layer to be able to test dynamic linking
   without having dynamic classloading fully in place. */

JNIEXPORT void JNICALL Java_DynLinkTest_callDynLinkedFunc
  (JNIEnv *env, jclass clazz, jstring jLibName, jstring jFuncName)
{
    const char *libName;
    const char *funcName;
    void *handle;
    void (*func)(void);

    libName = (*env)->GetStringUTFChars(env, jLibName, NULL);
    funcName = (*env)->GetStringUTFChars(env, jFuncName, NULL);
    handle = CVMdynlinkOpen(libName);
    if (handle == NULL) {
	(*env)->ThrowNew(env,
			 (*env)->FindClass(env, "java/lang/RuntimeException"),
			 "Error opening library");
	return;
    }
    func = (void (*)(void)) CVMdynlinkSym(handle, funcName);
    if (func == NULL) {
	(*env)->ThrowNew(env,
			 (*env)->FindClass(env, "java/lang/RuntimeException"),
			 "Error finding function");
	return;
    }
    (*func)();
}
