/*
 * @(#)DynLinkTest.java	1.3 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
/** Test dynamic linking functionality. Since we don't have full
    dynamic classloading support, call the dynamic linking routines
    from a native method. This test takes two string arguments: the
    first is the pathname of the shared object to load, and the second
    is the name of the function in it to call. The function must
    return void and take no arguments. */

public class DynLinkTest {
    public static void usage() {
	System.out.println("usage: cvm DynLinkTest <pathname of shared object to load> <name of function in it to call>");
	System.out.println("The function must return void and take no arguments.");
    }

    private static native void callDynLinkedFunc(String sharedObjectPathname,
						 String functionName);

    public static void main(String[] args) {
	if (args.length != 2) {
	    usage();
	    return;
	}
	
	callDynLinkedFunc(args[0], args[1]);
    }
}
