/*
 * @(#)DMArrayCopyBooleanTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayCopyBooleanTest extends Thread {

   private boolean [] privateArray;
   public static Object lock;

   public DMArrayCopyBooleanTest(int num) {
      privateArray = new boolean[num];
   }

   private native void nSetArray(boolean [] srcArray, boolean [] dstArray);

   public void setArray(boolean [] srcArray) {
	this.nSetArray(srcArray, this.privateArray);
   }

   public boolean getArrayElement(int index) {
        return (privateArray[index]);
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;

      arrayLength = getArrayLength();

      System.out.println();

      boolean [] boolArray = new boolean[arrayLength];
      for(int i=0; i<arrayLength; i++) {
         if(i%2 == 0)
            boolArray[i] = true;
         else
            boolArray[i] = false;
      }

      setArray(boolArray);

      for(int i=0; i<arrayLength; i++) {
         if(getArrayElement(i) != boolArray[i]) {
            pass = false;	
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayCopyBooleanTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayCopyBooleanTest, Data written and read were not same");
   }

   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayCopyBooleanTest.lock = lck;
      GcThread.lock = lck;

      DMArrayCopyBooleanTest test = new DMArrayCopyBooleanTest(rd.nextInt(100));
      GcThread gc = new GcThread();

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }
}
