/*
 * @(#)DMArrayCopyLongTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayCopyLongTest extends Thread {

   private long [] privateArray;
   public static Object lock;

   public DMArrayCopyLongTest(int num) {
      privateArray = new long[num];
   }

   private native void nSetArray(long [] srcArray, long [] dstArray);

   public void setArray(long [] srcArray) {
	this.nSetArray(srcArray, this.privateArray);
   }

   public long getArrayElement(int index) {
      return(privateArray[index]);
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      System.out.println();

      long [] longArray = new long[arrayLength];
      for(int i=0; i<arrayLength; i++)
         longArray[i] = rd.nextLong();

      setArray(longArray);

      for(int i=0; i<arrayLength; i++) {
         if(getArrayElement(i) != longArray[i]) {
            pass = false;	
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayCopyLongTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayCopyLongTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayCopyLongTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayCopyLongTest test = new DMArrayCopyLongTest(rd.nextInt(100));

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
