/*
 * @(#)DMArrayRWBodyByteTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayRWBodyByteTest extends Thread {

   private byte [] privateArray;
   public static Object lock;

   public DMArrayRWBodyByteTest(int num) {
      privateArray = new byte[num];
   }

   private native void nSetArray(byte[] dstArray, byte[] srcArray, int arrayLength);

   public void setArray(byte [] srcArray) {
        this.nSetArray(this.privateArray, srcArray, getArrayLength());
   }

   public byte [] getArray() {
      int arrLength = getArrayLength();
      byte [] byteArray = new byte[arrLength];

      for(int i=0; i<arrLength; i++)
         byteArray[i] = privateArray[i];

       return byteArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      byte [] inArray = new byte[arrayLength];
      rd.nextBytes(inArray);

      setArray(inArray);
      byte [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(inArray[i] != outArray[i]) {
            pass = false;
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayRWBodyByteTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayRWBodyByteTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayRWBodyByteTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayRWBodyByteTest test = new DMArrayRWBodyByteTest(rd.nextInt(100));

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
