/*
 * @(#)DMArrayRWBodyCharTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayRWBodyCharTest extends Thread {

   private char [] privateArray;
   public static Object lock;

   public DMArrayRWBodyCharTest(int num) {
      privateArray = new char[num];
   }

   private native void nSetArray(char[] dstArray, char[] srcArray, int arrayLength);

   public void setArray(char [] srcArray) {
        this.nSetArray(this.privateArray, srcArray, getArrayLength());
   }

   public char [] getArray() {
      int arrLength = getArrayLength();
      char [] charArray = new char[arrLength];

      for(int i=0; i<arrLength; i++)
         charArray[i] = privateArray[i];

       return charArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      char [] inArray = new char[arrayLength];
      for(int i=0; i<arrayLength; i++)
         inArray[i] = Character.forDigit(rd.nextInt(Character.MAX_RADIX), Character.MAX_RADIX);

      setArray(inArray);
      char [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(inArray[i] != outArray[i]) {
            pass = false;
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayRWBodyCharTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayRWBodyCharTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayRWBodyCharTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayRWBodyCharTest test = new DMArrayRWBodyCharTest(rd.nextInt(100));

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
