/*
 * @(#)DMArrayRWBodyFloatTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayRWBodyFloatTest extends Thread {

   private float [] privateArray;
   public static Object lock;

   public DMArrayRWBodyFloatTest(int num) {
      privateArray = new float[num];
   }

   private native void nSetArray(float[] dstArray, float[] srcArray, int arrayLength);

   public void setArray(float [] srcArray) {
        this.nSetArray(this.privateArray, srcArray, getArrayLength());
   }

   public float [] getArray() {
      int arrLength = getArrayLength();
      float [] floatArray = new float[arrLength];

      for(int i=0; i<arrLength; i++)
         floatArray[i] = privateArray[i];

       return floatArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      float [] inArray = new float[arrayLength];
      for(int i=0; i<arrayLength; i++)
         inArray[i] = rd.nextFloat();

      setArray(inArray);
      float [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(inArray[i] != outArray[i]) {
            pass = false;
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayRWBodyFloatTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayRWBodyFloatTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayRWBodyFloatTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayRWBodyFloatTest test = new DMArrayRWBodyFloatTest(rd.nextInt(100));

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
