/*
 * @(#)DMArrayRWIntTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayRWIntTest extends Thread {

   private int [] privateArray;
   public static Object lock;

   public DMArrayRWIntTest(int num) {
      privateArray = new int[num];
   }

   private native void nSetArray(int [] dstArray, int [] srcArray, int arrayLength);

   public void setArray(int [] intArray) {
	this.nSetArray(this.privateArray, intArray, getArrayLength());
   }

   public int [] getArray() {
      int arrLength = getArrayLength();
      int [] intArray = new int[arrLength];

      for(int i=0; i<arrLength; i++)
         intArray[i] = privateArray[i];

       return intArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      int [] inArray = new int[arrayLength];
      for(int i=0; i<arrayLength; i++)
         inArray[i] = rd.nextInt();

      setArray(inArray);
      int [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(outArray[i] != inArray[i]) {
            pass = false;       
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayRWIntTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayRWIntTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayRWIntTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayRWIntTest test = new DMArrayRWIntTest(rd.nextInt(100));

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
