/*
 * @(#)DMFieldRWDoubleTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMFieldRWDoubleTest extends Thread {

   public double publicVar;
   private double privateVar;
   protected double protectedVar;
   public static Object lock;

   public DMFieldRWDoubleTest() {
      publicVar = 0.0;
      privateVar = 0.0;
      protectedVar = 0.0;
   }

   public native void nSetValues(double v1, double v2, double v3);

   public native double [] nGetValues();

   public double [] getValues() {
      double [] doubleArray = {publicVar, privateVar, protectedVar};
      return doubleArray;
   }

   public void run() {
      boolean pass=true;
      Random rd = new Random();
      double [] var = {rd.nextDouble(), rd.nextDouble(), rd.nextDouble()};

      System.out.println();

      nSetValues(var[0], var[1], var[2]);

      System.out.println();

      double [] doubleArray1 = getValues();
      double [] doubleArray2 = nGetValues();

      if(doubleArray1.length == doubleArray2.length) {
         for(int i=0; i<doubleArray1.length; i++) {
            if(doubleArray1[i] != doubleArray2[i]) {
               pass = false;	
               break;
            }
         }
      }
      else {
         pass = false;
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMFieldRWDoubleTest, Data written and read were same");
      else
         System.out.println("FAIL: DMFieldRWDoubleTest, Data written and read were not same");

   }

   public static void main(String args[]) {
      Object lck = new Object();

      DMFieldRWDoubleTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMFieldRWDoubleTest test = new DMFieldRWDoubleTest();

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}

