/*
 * @(#)IDArrayRWIntTest.c	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#include "javavm/export/jvm.h"
#include "javavm/export/jni.h"
#include "native/common/jni_util.h"
#include "javavm/include/interpreter.h"
#include "javavm/include/gc_common.h"
#include "javavm/include/porting/threads.h"
#include "javavm/include/porting/time.h"
#include "javavm/include/porting/int.h"
#include "javavm/include/porting/doubleword.h"
#include "javavm/include/clib.h"
#include "javavm/include/indirectmem.h"
#include "javavm/include/directmem.h"
#include "javavm/include/globalroots.h"
#include "javavm/include/localroots.h"
#include "javavm/include/preloader.h"
#include "javavm/include/common_exceptions.h"
#include "generated/offsets/java_lang_Class.h"
#include "generated/offsets/java_lang_Thread.h"
#include "generated/offsets/java_lang_Throwable.h"
#include "generated/jni/java_lang_reflect_Modifier.h"
#include <stdio.h>
#include "IDArrayRWIntTest.h"


JNIEXPORT void JNICALL
Java_IDArrayRWIntTest_nSetArray(JNIEnv *env, jobject obj, 
                  jintArray dstArray, jintArray srcArray, jint arrayLength)
{
   jint i;
   jint val;
   CVMExecEnv *ee;

   ee = CVMjniEnv2ExecEnv(env);

      CVMD_gcUnsafeExec( ee, {
         CVMD_gcSafeExec(ee, {

            for(i=0; i<arrayLength; i++) {
               CVMID_arrayReadInt(ee, (CVMArrayOfIntICell*) srcArray, i, val);
               CVMID_arrayWriteInt(ee, (CVMArrayOfIntICell*) dstArray, i, val);
            }

         });
      });
}
