/*
 * @(#)IDArrayRWRefTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class IDArrayRWRefTest extends Thread {

   private String [] privateArray;

   public IDArrayRWRefTest(int num) {
      privateArray = new String[num];
   }

   private native void nSetArray(String [] dstArray, String [] srcArray, int arrayLength);

   public void setArray(String [] strArray) {
	this.nSetArray(this.privateArray, strArray, getArrayLength());
   }

   public String [] getArray() {
      int arrLength = getArrayLength();
      String [] strArray = new String[arrLength];
 
      for(int i=0; i<arrLength; i++)
         strArray[i] = privateArray[i];

       return strArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      String [] inArray = new String[arrayLength];
      for(int i=0; i<arrayLength; i++)
         inArray[i] = String.valueOf(rd.nextInt());

      setArray(inArray);
      String [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(outArray[i] != inArray[i]) {
            pass = false;	
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: IDArrayRWRefTest, Data written and read were same");
      else
         System.out.println("FAIL: IDArrayRWRefTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      int numGcThreads = 10;
      Random rd = new Random();

      IDArrayRWRefTest test = new IDArrayRWRefTest(rd.nextInt(100));

      GcThread.sleepCount = numGcThreads;
      GcThread [] gc = new GcThread[numGcThreads];
      for(int i=0; i<gc.length; i++) {
         gc[i] = new GcThread();
         gc[i].start();
      }

      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      for(int i=0; i<gc.length; i++) {
         gc[i].interrupt();
      }

      try {
         for(int i=0; i<gc.length; i++) {
            gc[i].join();
         }
      } catch (Exception e) {}
   }

}
