/*
 * @(#)IDArrayRWShortTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class IDArrayRWShortTest extends Thread {

   private short [] privateArray;

   public IDArrayRWShortTest(int num) {
      privateArray = new short[num];
   }

   private native void nSetArray(short [] dstArray, short [] srcArray, int arrayLength);

   public void setArray(short [] shortArray) {
	this.nSetArray(this.privateArray, shortArray, getArrayLength());
   }

   public short [] getArray() {
      int arrLength = getArrayLength();
      short [] shortArray = new short[arrLength];

      for(int i=0; i<arrLength; i++)
         shortArray[i] = privateArray[i];

       return shortArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      short [] inArray = new short[arrayLength];
      for(int i=0; i<arrayLength; i++)
         inArray[i] = (short) rd.nextInt();

      setArray(inArray);
      short [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(outArray[i] != inArray[i]) {
            pass = false;       
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: IDArrayRWShortTest, Data written and read were same");
      else
         System.out.println("FAIL: IDArrayRWShortTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      int numGcThreads = 10;
      Random rd = new Random();

      IDArrayRWShortTest test = new IDArrayRWShortTest(rd.nextInt(100));

      GcThread.sleepCount = numGcThreads;
      GcThread [] gc = new GcThread[numGcThreads];
      for(int i=0; i<gc.length; i++) {
         gc[i] = new GcThread();
         gc[i].start();
      }

      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      for(int i=0; i<gc.length; i++) {
         gc[i].interrupt();
      }

      try {
         for(int i=0; i<gc.length; i++) {
            gc[i].join();
         }
      } catch (Exception e) {}
   }

}
