/*
 * @(#)BarrierTest.c	1.1 00/10/30
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#include "javavm/export/jvm.h"
#include "javavm/export/jni.h"
#include "native/common/jni_util.h"
#include "javavm/include/interpreter.h"
#include "javavm/include/gc_common.h"
#include "javavm/include/porting/threads.h"
#include "javavm/include/porting/time.h"
#include "javavm/include/porting/int.h"
#include "javavm/include/porting/doubleword.h"
#include "javavm/include/clib.h"
#include "javavm/include/indirectmem.h"
#include "javavm/include/directmem.h"
#include "javavm/include/globalroots.h"
#include "javavm/include/localroots.h"
#include "javavm/include/preloader.h"
#include "javavm/include/common_exceptions.h"
#include "generated/offsets/java_lang_Class.h"
#include "generated/offsets/java_lang_Thread.h"
#include "generated/offsets/java_lang_Throwable.h"
#include "generated/jni/java_lang_reflect_Modifier.h"
#include "generated/offsets/java_lang_String.h"
#include "generated/jni/java_lang_String.h"
#include <stdio.h>
#include "BarrierTest.h"


JNIEXPORT jint JNICALL
Java_BarrierTest_checkCardMarking(JNIEnv *env, jobject obj)
{
   jint card = -1;
   CVMExecEnv *ee = CVMjniEnv2ExecEnv(env);

   CVMD_gcUnsafeExec( ee, {
      CVMObject *directObject = CVMID_icellDirect(ee, obj);
      CVMArrayOfRef* directArray;
      CVMObject** elemLoc;
      /* Read testStringArray[] off of BarrierTest */
      CVMD_fieldReadRef(directObject, FIELD_OFFSET(0),(CVMObject*)directArray);
      elemLoc = (CVMObject**)CVMDprivate_arrayElemLoc(directArray, 192);

      card = cardTable[(((int)elemLoc) - ((int) heapBase))/NUM_BYTES_PER_CARD];
   } );
   return card;
}

static void
CVMgcRunGCWithGoal(CVMExecEnv* ee, CVMUint32 goal)
{
    CVMSysMutex* heapLock = &CVMglobals.heapLock;
    CVMsysMutexLock(ee, heapLock);
    CVMD_gcUnsafeExec(ee, {
        (void)CVMgcStopTheWorldAndGC(ee, goal); /* Do a GC with goal */
    });
    CVMsysMutexUnlock(ee, heapLock);
}

JNIEXPORT void JNICALL
Java_BarrierTest_doYoungGC(JNIEnv *env, jclass clazz)
{
   CVMExecEnv *ee = CVMjniEnv2ExecEnv(env);
   CVMgcRunGCWithGoal(ee, 1024 * 500);
}
