/*
 * @(#)ReflectionBug.java	1.2 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
import java.lang.reflect.*;

/** Illustrates a bug in Java 1.2's specification of
  Field.set{Boolean,Int,...}. These and the Field.get{primitive}
  operations should NOT be specified in terms of Field.set and
  Field.get because (a) it's confusing and (b) as shown here,
  Field.set wasn't precise enough and is therefore wrong. */

public class ReflectionBug {
    public Boolean field = new Boolean(false);

    public static void main(String[] args) {
	ReflectionBug bug = new ReflectionBug();
	Class bugClass = bug.getClass();
	try {
	    Field bugField = bugClass.getField("field");
	    bugField.set(bug, new Boolean(true));
	    if (bug.field.booleanValue() == false) {
		System.out.println("Internal error in test");
	    }
	    bug.field = new Boolean(false);
	    bugField.setBoolean(bug, true);
	    if (bug.field.booleanValue() == true) {
		System.out.println("No bug found.");
	    }
	}
	catch (Exception e) {
	    System.out.println("Bug in JDK 1.2 reflection spec");
	}
    }
}
