/*
 * @(#)ClassComponent.java	1.2 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

package components;
import java.io.DataOutput;
import java.io.IOException;

/*
 * An abstract class for representing components of a class
 * This include any field, method, or "constant".
 */

public
abstract class ClassComponent
{
    // whether or not "resolved" has been called, 
    // which sometimes determines interpretation
    public boolean resolved = false;


    abstract public void write( DataOutput o ) throws IOException;


    public void resolve( ConstantObject table[] ){
	// by default, just note that we're resolved.
	resolved = true;
    }

    public void
    externalize( ConstantPool p ){
	// by default, there's nothing to do
    }

}
