/*
 * @(#)CVMOffsetsHeader.java	1.5 00/11/07
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

package runtime;
import Const;
import jcc.Util;
import util.*;
import components.*;
import vm.*;
import java.io.PrintStream;
import java.util.Enumeration;
import java.util.Vector;
import java.util.Hashtable;

public class CVMOffsetsHeader extends HeaderDump {

    private String cdelimClassName = null;

    public CVMOffsetsHeader( ){
	super( '_' );
    }

    private void prolog(){
	o.println("/* DO NOT EDIT THIS FILE - it is machine generated */\n" +
	    "#include \"javavm/include/defs.h\"\n" +
	    "#include \"javavm/include/objects.h\"\n" +
	    "#include \"javavm/include/classes.h\"\n" +
	    "#include \"javavm/include/preloader_impl.h\"\n");
	o.println("/* Header for class "+className+" */\n");
	String includeName = "_CVM_OFFSETS_"+cdelimClassName;
	o.println("#ifndef "+includeName);
	o.println("#define "+includeName+"\n");
    }

    private void epilog(){
	o.println("\n#endif");
    }

    synchronized public boolean
    dumpHeader( ClassInfo c, PrintStream outfile ){
	boolean didWork = false;
	o = outfile;
	className = c.className;
	cdelimClassName = strsub(className, CDelim);
	prolog();
	// Note: Should deal with > 255 fields.
	// Today is not that day. Just do the simple case.
	FieldInfo m[] = c.fields;
	if ( (m == null) || (m.length== 0)){
	    outfile.println("/* No fields for class "+cdelimClassName+" */\n");
	    return true;
	}
	int nfields = m.length;
	String prefix = "CVMoffsetOf"+cdelimClassName+"_";
	for ( int i = 0; i < nfields; i++ ){
	    FieldInfo f = m[i];
	    // static members use simple byte offset
	    // instance members include size of header info
	    if ( !f.isStaticMember() ){
		didWork = true;
		outfile.print("#define ");
		outfile.print(prefix + f.name.string + " \t");
		outfile.println("FIELD_OFFSET("+f.instanceOffset+")");
	    } 
	}
	if (!didWork) {
	    outfile.println("/* No instance fields for class "+cdelimClassName+" */\n");
	}
	epilog();
	return true;
    }

}
