/*
 * @(#)CVMMemberNameEntry.java	1.3 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
package vm;
import java.util.Vector;

/*
 * Collect member names. Turn them into little integers.
 * Build a hash table of them for writing out to the romjava image.
 */
public class CVMMemberNameEntry{
/* instance members */
    public String		name;
    public CVMMemberNameEntry	next;
    public int			entryNo;

/* static members */
    public final static int NMEMBERNAMEHASH = 41*13;
    public static CVMMemberNameEntry hash[] = new CVMMemberNameEntry[ NMEMBERNAMEHASH ];
    static int 		nextEntryNo = 0;
    public static Vector table = new Vector();

/* constructor &c */

    static synchronized void enlist( CVMMemberNameEntry x, int xhash ){
	x.entryNo = nextEntryNo++;
	table.addElement( x );
	x.next = hash[xhash];
	hash[xhash] = x;
    }

    CVMMemberNameEntry( String myname, int myhash ){
	name = myname;
	enlist( this, myhash );
    }

/* static methods */
    /*
     * We use a very simple minded name hashing scheme.
     * Based on the LAST few letters of the name, which are
     * the most likely to differ, I believe.
     * Same as for CVMDataType.
     */
    public static int
    computeHash( String name ){
	int v = 0;
	int t = name.length();
	int n = Math.min( t, 7 );
	t -= n;
	while ( n--> 0 ){
	    v = (v*19) + name.charAt(t+n) - '/';
	}
	return v;
    }

    public static int lookupEnter( String name ){
	int hval = (int)(((long)(computeHash( name ))&0xffffffffL) % NMEMBERNAMEHASH);
	name = name.intern();
	CVMMemberNameEntry mne;
	for ( mne = hash[hval]; mne!=null; mne = mne.next ){
	    if ( mne.name == name ) return mne.entryNo;
	}
	return new CVMMemberNameEntry( name, hval).entryNo;
    }

    public static int tableSize(){
	return nextEntryNo;
    }
}
