/*
 * @(#)Thread.c	1.77 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*-
 *      Stuff for dealing with threads.
 *      originally in threadruntime.c, Sun Sep 22 12:09:39 1991
 */

#include "jni.h"
#include "jvm.h"

#include "java_lang_Thread.h"

#define THD "Ljava/lang/Thread;"
#define OBJ "Ljava/lang/Object;"

#ifndef JDK12
JNIEXPORT void JNICALL
Java_java_lang_Thread_clearInterrupted(JNIEnv *env, jclass cls);
#endif

static JNINativeMethod methods[] = {
    {"start",            "()V",        (void *)&JVM_StartThread},
#ifdef JDK12
    {"stop0",            "(" OBJ ")V", (void *)&JVM_StopThread},
    {"isAlive",          "()Z",        (void *)&JVM_IsThreadAlive},
#endif
#ifdef CVM_HAVE_DEPRECATED
    {"suspend0",         "()V",        (void *)&JVM_SuspendThread},
    {"resume0",          "()V",        (void *)&JVM_ResumeThread},
#endif
    {"setPriority0",     "(I)V",       (void *)&JVM_SetThreadPriority},
    {"yield",            "()V",        (void *)&JVM_Yield},
    {"sleep",            "(J)V",       (void *)&JVM_Sleep},
    {"currentThread",    "()" THD,     (void *)&JVM_CurrentThread},
#ifdef CVM_HAVE_DEPRECATED
    {"countStackFrames", "()I",        (void *)&JVM_CountStackFrames},
#endif
    {"interrupt0",       "()V",        (void *)&JVM_Interrupt},
    {"isInterrupted",    "(Z)Z",       (void *)&JVM_IsInterrupted},
};

#undef THD
#undef OBJ

JNIEXPORT void JNICALL
Java_java_lang_Thread_registerNatives(JNIEnv *env, jclass cls)
{
    (*env)->RegisterNatives(env, cls, methods, 12);
}

#include "javavm/include/indirectmem.h"

/* CVM only.  Perhaps all Thread natives should be changed to use CNI */
JNIEXPORT void JNICALL
Java_java_lang_Thread_setCurrentThread(JNIEnv *env, jclass cls, jobject thread)
{
    CVMExecEnv *ee = CVMjniEnv2ExecEnv(env);
    CVMID_icellAssign(ee, CVMcurrentThreadICell(ee), thread);
}
